;################################################################################
;#										#
;# avr-chipbasic2M - mobile single chip basic computer with ATmega644		#
;# GUI functions								#
;# copyright (c) 2008 Joerg Wolfram (joerg@jcwolfram.de)			#
;#										#
;#										#
;# This program is free software; you can redistribute it and/or		#
;# modify it under the terms of the GNU General Public License			#
;# as published by the Free Software Foundation; either version 2		#
;# of the License, or (at your option) any later version.			#
;#										#
;# This program is distributed in the hope that it will be useful,		#
;# but WITHOUT ANY WARRANTY; without even the implied warranty of		#
;# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.See the GNU		#
;# General Public License for more details.					#
;#										#
;# You should have received a copy of the GNU General Public			#
;# License along with this library; if not, write to the			#
;# Free Software Foundation, Inc., 59 Temple Place - Suite 330,			#
;# Boston, MA 02111-1307, USA.							#
;#										#
;################################################################################
;------------------------------------------------------------------------------
;draw 8 button menu Z=pointer to 20 chars and bitmap
;tempreg2=entry
;tempreg1=key
;T=0 only select T=1 complete
;------------------------------------------------------------------------------
libmio_menu8:	push	ZH			;save registers
		push	ZL
		push	YH
		push	YL
		push	XH
		push	XL
		push	tempreg3
		push	tempreg4
		clr	ctrl			;normal mode
		sts	libmio_channel,const_0	;output to screen
		sts	libmio_color,const_1	;set normal color
		sts	libmio_font,const_0	;set normal font
		brtc	libmio_menu8_6		;only entries	
		movw	XL,ZL			;save pointer
		call	libmio_clr
		ldi	YL,0			;X1
		ldi	YH,0	
		ldi	ZL,127
		ldi	ZH,9
		rcall	libmio_fbox
		movw	ZL,XL			;restore pointer

;title bar
		sts	libmio_color,const_0	;set inverse color
		ldi	XL,4			;position
		ldi	XH,0
		rcall	libmio_gxy		;set
		ldi	YL,LOW(libmio_mram)
		ldi	YH,HIGH(libmio_mram)
		ldi	XL,20			;number of chars
libmio_menu8_2:	lpm	tempreg1,Z+
		rcall	libmio_char
		dec	XL
		brne	libmio_menu8_2
		sts	libmio_color,const_1	;set normal color
		rcall	libmio_dr8i		;draw empty icons
;copy bitmap
		ldi	YL,LOW(libmio_vram+192)
		ldi	YH,HIGH(libmio_vram+192)
		ldi	XL,176
libmio_menu8_4:	lpm	tempreg1,Z+
		st	Y+,tempreg1
		lpm	tempreg1,Z+
		st	Y+,tempreg1
		dec	XL
		brne	libmio_menu8_4
		adiw	YL,48
		adiw	YL,48
		ldi	XL,176
libmio_menu8_5:	lpm	tempreg1,Z+
		st	Y+,tempreg1
		lpm	tempreg1,Z+
		st	Y+,tempreg1
		dec	XL
		brne	libmio_menu8_5
		
libmio_menu8_6:	rcall	libmio_iven8
		rcall	libmio_nokeys
libmio_menu8_7:	rcall	libmio_rtcwk	
		cpi	tempreg1,0xea		;enter
		breq	libmio_menu8_e		;leave
		cpi	tempreg1,0xed		;esc
		breq	libmio_menu8_e		;leave
		
		rcall	libmio_iven8		;re-invert
		cpi	tempreg1,0xe2		;left
		brne	libmio_menu8_8
		dec	tempreg2
		sbrc	tempreg2,7
		clr	tempreg2					
		rjmp	libmio_menu8_6

libmio_menu8_8:	cpi	tempreg1,0xe3		;right
		brne	libmio_menu8_9
		inc	tempreg2
		sbrc	tempreg2,3
		ldi	tempreg2,7					
		rjmp	libmio_menu8_6

libmio_menu8_9:	cpi	tempreg1,0xe4		;up
		brne	libmio_menu8_a
		subi	tempreg2,4
		sbrc	tempreg2,7
		subi	tempreg2,0xfc					
		rjmp	libmio_menu8_6

libmio_menu8_a:	subi	tempreg2,0xfc		;down
		sbrc	tempreg2,3
		subi	tempreg2,0x04					
		rjmp	libmio_menu8_6

libmio_menu8_e:	rjmp	libmio_menu5_e		;use part of other routine

;------------------------------------------------------------------------------
;draw 4 button menu
;tempreg2=entry
;tempreg1=key
;------------------------------------------------------------------------------
libmio_menu4:	push	ZH			;save registers
		push	ZL
		push	YH
		push	YL
		push	XH
		push	XL
		push	tempreg3
		push	tempreg4
		clr	ctrl			;normal mode
		sts	libmio_channel,const_0	;output to screen
		sts	libmio_color,const_1	;set normal color
		sts	libmio_font,const_0	;set normal font

		
libmio_menu4_6:	rcall	libmio_iven4
		rcall	libmio_nokeys
libmio_menu4_7:	rcall	libmio_rtcwk_5	
		cpi	tempreg1,0xea		;enter
		breq	libmio_menu4_e		;leave
		cpi	tempreg1,0xed		;esc
		breq	libmio_menu4_e		;leave
		
		rcall	libmio_iven4		;re-invert
		cpi	tempreg1,0xe2		;left
		brne	libmio_menu4_8
		dec	tempreg2
		sbrc	tempreg2,7
		clr	tempreg2					
		rjmp	libmio_menu4_6

libmio_menu4_8:	cpi	tempreg1,0xe3		;right
		brne	libmio_menu4_9
		inc	tempreg2
		sbrc	tempreg2,2
		ldi	tempreg2,3					
		rjmp	libmio_menu4_6

libmio_menu4_9:	cpi	tempreg1,0xe4		;up
		brne	libmio_menu4_a
		subi	tempreg2,2
		sbrc	tempreg2,7
		subi	tempreg2,0xfe					
		rjmp	libmio_menu4_6

libmio_menu4_a:	subi	tempreg2,0xfe		;down
		sbrc	tempreg2,2
		subi	tempreg2,0x02					
		rjmp	libmio_menu4_6

libmio_menu4_e:	rjmp	libmio_menu5_e		;use part of other routine


;------------------------------------------------------------------------------
;draw 4 empty icons
;------------------------------------------------------------------------------
libmio_dr4i:	push	ZH
		push	ZL
		push	YH
		push	YL
		push	XH
		push	XL
		push	r16
		ldi	YL,LOW(libmio_vram+144)		;initial pos
		ldi	YH,HIGH(libmio_vram+144)
		
		rcall	libmio_dr4i_i			;upper block
		adiw	YL,16				;skip 2 lines
		rcall	libmio_dr4i_i			;lower block
		rjmp	libmio_dr8i_e			;end
		
libmio_dr4i_i:	ldi	ZL,LOW(libmio_dr4i_tp*2)	;first pattern
		ldi	ZH,HIGH(libmio_dr4i_tp*2)			
		rcall	libmio_dr4i_r			;row 1
		adiw	ZL,8				;next pattern
		rcall	libmio_dr4i_r			;row 1
		adiw	ZL,8				;next pattern
		rcall	libmio_dr4i_r			;row 2
		adiw	ZL,8				;next pattern
		rcall	libmio_dr4i_r			;row 3
		adiw	ZL,8				;next pattern				
		
		ldi	XH,5				;number of lines		
libmio_dr4i_i1:	rcall	libmio_dr4i_r			;row 4-7
		dec	XH
		brne	libmio_dr4i_i1
		adiw	ZL,8				;next pattern
		rcall	libmio_dr4i_r			;row 8
		sbiw	ZL,8		
		ldi	XH,14				;number of lines		
libmio_dr4i_i2:	rcall	libmio_dr4i_r			;row 9-23
		dec	XH
		brne	libmio_dr4i_i2		
				
		sbiw	ZL,8
		rcall	libmio_dr4i_r			;row 24
		sbiw	ZL,8
		rcall	libmio_dr4i_r			;row 25			
		sbiw	ZL,8
		
libmio_dr4i_r:	ldi	XL,2				;blocks
libmio_dr4i_r1:	ldi	r16,8				;bytes per block
libmio_dr4i_r2:	lpm	r0,Z+
		st	Y+,r0
		dec	r16
		brne	libmio_dr4i_r2
		sbiw	ZL,8
		dec	XL
		brne	libmio_dr4i_r1		
		ret						
		
		
libmio_dr4i_tp:	.db	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
		.db	0xf0,0xff,0xff,0xff,0xff,0xff,0xff,0x0f
		.db	0x08,0x00,0x00,0x00,0x00,0x00,0x00,0x10
		.db	0x04,0x00,0x00,0x00,0x00,0x00,0x00,0x20
		.db	0x02,0x00,0x00,0x00,0x00,0x00,0x00,0x40
		.db	0xfe,0xff,0xff,0xff,0xff,0xff,0xff,0x7f			
			

;------------------------------------------------------------------------------
;draw 8 empty icons
;------------------------------------------------------------------------------
libmio_dr8i:	push	ZH
		push	ZL
		push	YH
		push	YL
		push	XH
		push	XL
		push	r16
		ldi	YL,LOW(libmio_vram+144)		;initial pos
		ldi	YH,HIGH(libmio_vram+144)
		
		rcall	libmio_dr8i_i			;upper block
		adiw	YL,16				;skip 2 lines
		rcall	libmio_dr8i_i			;lower block
libmio_dr8i_e:	pop	r16
		pop	XL
		pop	XH
		pop	YL
		pop	YH
		pop	ZL
		pop	ZH	
		ret
		
libmio_dr8i_i:	ldi	ZL,LOW(libmio_dr8i_tp*2)	;first pattern
		ldi	ZH,HIGH(libmio_dr8i_tp*2)			
		rcall	libmio_dr8i_r			;row 1
		adiw	ZL,4				;next pattern
		rcall	libmio_dr8i_r			;row 2
		adiw	ZL,4				;next pattern
		rcall	libmio_dr8i_r			;row 3
		adiw	ZL,4				;next pattern				
		rcall	libmio_dr8i_r			;row 3
		adiw	ZL,4				;next pattern				
		
		ldi	XH,5				;number of lines		
libmio_dr8i_i1:	rcall	libmio_dr8i_r			;row 4-7
		dec	XH
		brne	libmio_dr8i_i1
		adiw	ZL,4				;next pattern
		rcall	libmio_dr8i_r			;row 8
		sbiw	ZL,4		
		ldi	XH,14				;number of lines		
libmio_dr8i_i2:	rcall	libmio_dr8i_r			;row 9-23
		dec	XH
		brne	libmio_dr8i_i2		
				
		sbiw	ZL,4
		rcall	libmio_dr8i_r			;row 24
		sbiw	ZL,4
		rcall	libmio_dr8i_r			;row 25			
		sbiw	ZL,4							
		
libmio_dr8i_r:	ldi	XL,4				;blocks
libmio_dr8i_r1:	ldi	r16,4				;bytes per block
libmio_dr8i_r2:	lpm	r0,Z+
		st	Y+,r0
		dec	r16
		brne	libmio_dr8i_r2
		sbiw	ZL,4
		dec	XL
		brne	libmio_dr8i_r1		
		ret				
		
libmio_dr8i_tp:	.db	0x00,0x00,0x00,0x00
		.db	0xf0,0xff,0xff,0x0f
		.db	0x08,0x00,0x00,0x10
		.db	0x04,0x00,0x00,0x20
		.db	0x02,0x00,0x00,0x40
		.db	0xfe,0xff,0xff,0x7f			

;------------------------------------------------------------------------------
;draw menu-head from Z (flash)
;------------------------------------------------------------------------------		
libmio_mheadf:	clr	ctrl			;normal mode
		sts	libmio_channel,const_0	;output to screen
		sts	libmio_color,const_1	;set normal color
		sts	libmio_font,const_0	;set normal font
		rcall	libmio_clr
		push	ZH
		push	ZL
		ldi	YL,0			;filled box
		ldi	YH,0
		ldi	ZL,127
		ldi	ZH,9
		rcall	libmio_fbox				
	    	sts	libmio_color,const_0	;inverse color
	    	pop	ZL
	    	pop	ZH
		rcall	libmio_orom		;output flash header text		
		sts	libmio_color,const_1	;set normal color		
	    	ret		
				
;------------------------------------------------------------------------------
;wait for KEY and show RTC in status line 
;------------------------------------------------------------------------------
libmio_rtcwk:	lds	XL,libmio_rtc		;have RTC
		sbrs	XL,1			;skip if enabled
		rjmp	libmio_rtcwk_0
		sbrc	XL,0			;skip if have not
		rjmp	libmio_rtcwk_1
libmio_rtcwk_0:	rcall	libmio_waitkey
		ret		
		
libmio_rtcwk_1:	push	tempreg2
		push	tempreg4
		sts	libmio_color,const_0	;inverse		
libmio_rtcwk_2:	sts	libmio_font,const_1	;little font
		ldi	XL,2
		ldi	XH,2
		rcall	libmio_gxy		;set pos for date
		ldi	YL,LOW(bas_array+256)
		ldi	YH,HIGH(bas_array+256)
		libi2c_rtc3232_read_date	;read date
		ldi	ZL,LOW(bas_array+256)
		ldi	ZH,HIGH(bas_array+256)
		rcall	libmio_oram		;output
		ldi	XL,96
		ldi	XH,2
		rcall	libmio_gxy		;set pos for date
		ldi	YL,LOW(bas_array+256)
		ldi	YH,HIGH(bas_array+256)
		libi2c_rtc3232_read_time	;read date
		ldi	ZL,LOW(bas_array+256)
		ldi	ZH,HIGH(bas_array+256)
		rcall	libmio_oram		;output
		ldi	XL,40
		ldi	XH,0
		rcall	libmio_gxy		;set pos for bell
		ldi	YL,LOW(bas_array+256)
		ldi	YH,HIGH(bas_array+256)
		libi2c_rtc3232_read_status	;read date
		sts	libmio_font,const_0	;normal font
		push	XL
		ldi	tempreg1,0x87		;bell
		sbrs	XL,0
		ldi	tempreg1,'-'
		libmio_outchar
		sts	libmio_vram+5+16*9,const_0		
		ldi	XL,48
		ldi	XH,0
		rcall	libmio_gxy		;set pos for log
		pop	XL
		ldi	tempreg1,0x85		;log
		sbrs	XL,1
		ldi	tempreg1,0x84		;no log
		libmio_outchar
		sts	libmio_vram+6+16*9,const_0		
		sts	libmio_font,const_0	;normal font
		
		lds	tempreg1,libmio_keycode
		cpi	tempreg1,0
		breq	libmio_rtcwk_x
		sts	libmio_color,const_1	;normal		
		sts	libmio_font,const_0	;normal font
		pop	tempreg4
		pop	tempreg2
		ret
libmio_rtcwk_x:	rjmp	libmio_rtcwk_2


;------------------------------------------------------------------------------
;wait for KEY and show RTC in status line 
;------------------------------------------------------------------------------
libmio_rtcwk_5:	lds	XL,libmio_rtc		;have RTC
		sbrc	XL,1			;skip if have not
		rjmp	libmio_rtcwk_6
		rcall	libmio_waitkey
		ret
libmio_rtcwk_6:	push	tempreg2
		push	tempreg4
		sts	libmio_color,const_0	;inverse		
		sts	libmio_font,const_1	;little font
libmio_rtcwk_7:	ldi	XL,6
		ldi	XH,2
		rcall	libmio_gxy		;set pos for date
		ldi	YL,LOW(bas_array+256)
		ldi	YH,HIGH(bas_array+256)
		libi2c_rtc3232_read_date	;read date
		ldi	ZL,LOW(bas_array+256)
		ldi	ZH,HIGH(bas_array+256)
		rcall	libmio_oram		;output
		ldi	XL,92
		ldi	XH,2
		rcall	libmio_gxy		;set pos for date
		ldi	YL,LOW(bas_array+256)
		ldi	YH,HIGH(bas_array+256)
		libi2c_rtc3232_read_time	;read date
		ldi	ZL,LOW(bas_array+256)
		ldi	ZH,HIGH(bas_array+256)
		rcall	libmio_oram		;output
		lds	tempreg1,libmio_keycode
		cpi	tempreg1,0
		breq	libmio_rtcwk_7
		sts	libmio_color,const_1	;normal		
		sts	libmio_font,const_0	;normal font
		
		pop	tempreg4
		pop	tempreg2
		ret
			
;------------------------------------------------------------------------------
;invert entry tempreg2
;------------------------------------------------------------------------------
libmio_iven8:	push	tempreg3
		push	tempreg4
		ldi	YL,LOW(libmio_vram+176)
		ldi	YH,HIGH(libmio_vram+176)
		ldi	XL,LOW(libmio_vram+624)
		ldi	XH,HIGH(libmio_vram+624)
		sbrc	tempreg2,2
		movw	YL,XL
		sbrc	tempreg2,1
		adiw	YL,8
		sbrc	tempreg2,0
		adiw	YL,4
		ldi	XL,20			;lines
		ldi	tempreg3,0xf0
		ldi	tempreg4,0x0f
		rcall	libmio_ivli8
		ldi	tempreg3,0xf8
		ldi	tempreg4,0x1f
		rcall	libmio_ivli8
		ldi	tempreg3,0xfc
		ldi	tempreg4,0x3f
libmio_iven8_1:	rcall	libmio_ivli8
		dec	XL
		brne	libmio_iven8_1
		ldi	tempreg3,0xf8
		ldi	tempreg4,0x1f
		rcall	libmio_ivli8
		ldi	tempreg3,0xf0
		ldi	tempreg4,0x0f
		rcall	libmio_ivli8
		pop	tempreg4
		pop	tempreg3					
		ret
		
;invert line
libmio_ivli8:	ld	XH,Y
		eor	XH,tempreg3		;invert1
		st	Y+,XH
		ld	XH,Y
		com	XH			;invert2
		st	Y+,XH
		ld	XH,Y
		com	XH			;invert3
		st	Y+,XH
		ld	XH,Y
		eor	XH,tempreg4		;invert4
		st	Y+,XH
		adiw	YL,12
		ret


;------------------------------------------------------------------------------
;invert entry tempreg2
;------------------------------------------------------------------------------
libmio_iven4:	push	tempreg3
		push	tempreg4
		ldi	YL,LOW(libmio_vram+176)
		ldi	YH,HIGH(libmio_vram+176)
		ldi	XL,LOW(libmio_vram+624)
		ldi	XH,HIGH(libmio_vram+624)
		sbrc	tempreg2,1
		movw	YL,XL
		sbrc	tempreg2,0
		adiw	YL,8
		ldi	XL,20			;lines
		ldi	tempreg3,0xf0
		ldi	tempreg4,0x0f
		rcall	libmio_ivli4
		ldi	tempreg3,0xf8
		ldi	tempreg4,0x1f
		rcall	libmio_ivli4
		ldi	tempreg3,0xfc
		ldi	tempreg4,0x3f
libmio_iven4_1:	rcall	libmio_ivli4
		dec	XL
		brne	libmio_iven4_1
		ldi	tempreg3,0xf8
		ldi	tempreg4,0x1f
		rcall	libmio_ivli4
		ldi	tempreg3,0xf0
		ldi	tempreg4,0x0f
		rcall	libmio_ivli4
		pop	tempreg4
		pop	tempreg3					
		ret
		
;invert line
libmio_ivli4:	ld	XH,Y
		eor	XH,tempreg3		;invert1
		st	Y+,XH
		push	XL
		ldi	XL,6
libmio_ivli41:	ld	XH,Y
		com	XH			;invert2-7
		st	Y+,XH
		dec	XL
		brne	libmio_ivli41
		pop	XL
		ld	XH,Y
		eor	XH,tempreg4		;invert8
		st	Y+,XH
		adiw	YL,8
		ret
		
	
;------------------------------------------------------------------------------
;copy text from flash to RAM (libmio_mram)
;Z=flash address
;------------------------------------------------------------------------------
libmio_copyram:	push	ZH
		push	ZL
		push	YH
		push	YL
		push	XH
		push	XL
		push	r16
		ldi	XL,5			;number of lines
		ldi	YL,LOW(libmio_mram)
		ldi	YH,HIGH(libmio_mram)
		ldi	XH,20
libmio_copyr_1:	lpm	r16,Z+			;copy head
		st	Y+,r16
		dec	XH		
		brne	libmio_copyr_1	
		
libmio_copyr_2:	ldi	XH,18
libmio_copyr_3:	lpm	r16,Z+
		st	Y+,r16
		dec	XH		
		brne	libmio_copyr_3
		dec	XL
		brne	libmio_copyr_2	
libmio_copyr_e:	pop	r16
		pop	XL
		pop	XH
		pop	YL
		pop	YH
		pop	ZL
		pop	ZH
		ret		

;------------------------------------------------------------------------------
;copy entry text from flash to RAM (18 chars)
;Z=Flash pointer
;Y=RAM pointer
;------------------------------------------------------------------------------
libmio_copyent:	push	XH
		push	r16
		ldi	XH,18	
libmio_copye1:	lpm	r16,Z+
		st	Y+,r16
		dec	XH		
		brne	libmio_copye1
		pop	r16
		pop	XH
		ret		
		
;------------------------------------------------------------------------------
;draw menu from RAM
;tempreg2=entry
;tempreg1=key
;r19=number of entries
;T=0 only entries T=1 complete
;------------------------------------------------------------------------------
libmio_menu5:	push	ZH			;save registers
		push	ZL
		push	YH
		push	YL
		push	XH
		push	XL
		push	tempreg3
		push	tempreg4
		sbrc	tempreg2,7
		ldi	tempreg2,0
libmio_menu5_1:	cpi	tempreg2,5		;limit to 0-4
		brcs	libmio_menu5_2
		ldi	tempreg2,4
libmio_menu5_2:	clr	ctrl			;normal mode
		sts	libmio_channel,const_0	;output to screen
		sts	libmio_color,const_1	;set normal color
		sts	libmio_font,const_0	;set normal font
		brtc	libmio_menu5_4		;draw only entries
		rcall	libmio_clr		;clear screen
		ldi	YL,0
		ldi	YH,4
		ldi	ZL,127
		ldi	ZH,63
		rcall	libmio_box
		sts	libmio_color,const_0	;set inverse color
;title bar
		ldi	XL,4			;position
		ldi	XH,0
		rcall	libmio_gxy		;set
		ldi	YL,LOW(libmio_mram)
		ldi	YH,HIGH(libmio_mram)
		ldi	XL,20			;number of chars
libmio_menu5_3:	ld	tempreg1,Y+
		rcall	libmio_char
		dec	XL
		brne	libmio_menu5_3
;entries
libmio_menu5_4:	clr	tempreg4
		ldi	YL,LOW(libmio_mram+20)
		ldi	YH,HIGH(libmio_mram+20)
		sbrc	tempreg2,7
		ldi	tempreg2,0
libmio_menu5_5:	cp	tempreg2,r19		;limit to 0-ereg
		brcs	libmio_menu5_6
		mov	tempreg2,r19
		dec	tempreg2
libmio_menu5_6:	sts	libmio_color,const_1	;set normal color
		ldi	XL,4			;X-position
		ldi	XH,12			;Y-position of first entry
		ldi	tempreg3,10		;entry height
		mul	tempreg4,tempreg3	;Y offset
		add	XH,r0
		rcall	libmio_gxy		;set
		cp	tempreg4,tempreg2	;selected?
		brne	libmio_menu5_8		;not
		
		ldi	tempreg1,0x9c		;left end
		rcall	libmio_char
		sts	libmio_color,const_0	;set inverse color
		ldi	XL,18			;number of chars
libmio_menu5_7:	ld	tempreg1,Y+
		rcall	libmio_char
		dec	XL
		brne	libmio_menu5_7
		sts	libmio_color,const_1	;set normal color	
		ldi	tempreg1,0x9d		;right end
		rcall	libmio_char
		rjmp	libmio_menu5_a
		
libmio_menu5_8:	rcall	libmio_space
		ldi	XL,18			;number of chars
libmio_menu5_9:	ld	tempreg1,Y+
		rcall	libmio_char
		dec	XL
		brne	libmio_menu5_9
		rcall	libmio_space
libmio_menu5_a:	inc	tempreg4
		cpi	tempreg4,5
		brne	libmio_menu5_6


libmio_menu5_b:	rcall	libmio_nokeys
		lds	tempreg3,libmio_rtc
		sbrs	tempreg3,1		
		rcall	libmio_waitkey		;wait for key
		sbrc	tempreg3,1		
		rcall	libmio_rtcwk_5		;wait for key with time anz

libmio_menu5_c:	cpi	tempreg1,0xe4		;up
		brne	libmio_menu5_d
		dec	tempreg2
		rjmp	libmio_menu5_4
		
libmio_menu5_d:	cpi	tempreg1,0xe5		;down
		brne	libmio_menu5_e
		inc	tempreg2
		rjmp	libmio_menu5_4

libmio_menu5_e:	clr	ereg
		pop	tempreg4
		pop	tempreg3
		pop	XL
		pop	XH
		pop	YL
		pop	YH
		pop	ZL
		pop	ZH
		ret		
		
;------------------------------------------------------------------------------
;alpha keyboard
;tempreg2=len
;------------------------------------------------------------------------------
libmio_akey:	push	ZH			;save registers
		push	ZL
		push	YH
		push	YL
		push	XH
		push	XL
		push	tempreg3
		push	tempreg4
		clr	tempreg4
		
		clr	ctrl			;normal mode
		sts	libmio_channel,const_0	;output to screen
		sts	libmio_color,const_1	;set normal color
		sts	libmio_font,const_0	;set normal font
		ldi	YL,0
		ldi	YH,0
		ldi	ZL,127
		ldi	ZH,63
		rcall	libmio_fbox
		sts	libmio_color,const_0	;set inverse color
		ldi	XL,2
		ldi	XH,2
		rcall	libmio_gxy		
		ldi	ZL,LOW(libmio_tram+32)
		ldi	ZH,HIGH(libmio_tram+32)
		ldi	XL,20
libmio_akey_0:	ld	tempreg1,Z+
		rcall	libmio_char
		dec	XL
		brne	libmio_akey_0		
					
;text field		
		ldi	YL,4
		ldi	YH,13
		ldi	ZH,26
		ldi	ZL,6
		mul	ZL,tempreg2
		ldi	ZL,5
		add	ZL,r0
		rcall	libmio_fbox
;key field		
		ldi	YL,3
		ldi	YH,29
		ldi	ZL,124
		ldi	ZH,60
		rcall	libmio_fbox
		sts	libmio_tptr,const_0	;text len is 0
;draw text
libmio_akey_1:	ldi	XL,5
		ldi	XH,15
		rcall	libmio_gxy
		sts	libmio_color,const_1	;set normal color
		ldi	ZL,LOW(libmio_tram)
		ldi	ZH,HIGH(libmio_tram)
		mov	XL,tempreg2
		clr	YL
		lds	YH,libmio_tptr
libmio_akey_2:	ld	tempreg1,Z+
		cp	YL,YH
		brne	libmio_akey_2a
		ldi	tempreg1,0x10		;pepper&salt
libmio_akey_2a:	rcall	libmio_char
		inc	YL
		dec	XL
		brne	libmio_akey_2
	
;keys
libmio_akey_3:	ldi	ZL,low(libmio_akdata*2)
		ldi	ZH,HIGH(libmio_akdata*2)
		ldi	YH,0			;pos
libmio_akey_4:	ldi	YL,0
libmio_akey_5:	ldi	XL,4			;initial pos
		ldi	XH,30
		ldi	tempreg1,6
		mul	tempreg1,YL
		add	XL,r0
		ldi	tempreg1,10
		mul	tempreg1,YH
		add	XH,r0	
		rcall	libmio_gxy
		sts	libmio_color,const_1	;set normal color
		mov	XL,YH
		ldi	XH,20
		mul	XL,XH
		mov	XL,YL
		add	XL,r0
		cp	XL,tempreg4
		brne	libmio_akey_6
		sts	libmio_color,const_0	;set invers color
libmio_akey_6:	lpm	tempreg1,Z+
		rcall	libmio_char
		inc	YL
		cpi	YL,20
		brne	libmio_akey_5
		inc	YH
		cpi	YH,3
		brne	libmio_akey_4
		
libmio_akey_7:	rcall	libmio_nokeys		;wait for key release
		rcall	libmio_waitkey		;wait for key
		cpi	tempreg1,0xed		;ESC?
		brne	libmio_akey_8		;no
		clt				;set invalid
		rjmp	libmio_menu5_e		;end		

libmio_akey_8:	cpi	tempreg1,0xea		;ENTER?
		brne	libmio_akey_9		;no
		rjmp	libmio_akey_10		;loop
		
libmio_akey_9:	cpi	tempreg1,0xe2		;left
		brne	libmio_akey_a
		cpi	tempreg4,0
		breq	libmio_akey_7
		dec	tempreg4
		rjmp	libmio_akey_3
		
libmio_akey_a:	cpi	tempreg1,0xe3		;right
		brne	libmio_akey_b
		cpi	tempreg4,59
		breq	libmio_akey_7
		inc	tempreg4
		rjmp	libmio_akey_3

libmio_akey_b:	cpi	tempreg1,0xe4		;up
		brne	libmio_akey_c
		cpi	tempreg4,20
		brcs	libmio_akey_7
		subi	tempreg4,20
		rjmp	libmio_akey_3

libmio_akey_c:	cpi	tempreg4,40		;down
		brcc	libmio_akey_7
		subi	tempreg4,0xec		;+20
		rjmp	libmio_akey_3
		
libmio_akey_10:	
libmio_akey_11:	cpi	tempreg4,59		;enter?
		brne	libmio_akey_12		;no
		set				;set valid
		rjmp	libmio_menu5_e		;end

libmio_akey_12:	cpi	tempreg4,58		;backspace?
		brne	libmio_akey_13		;no
		lds	tempreg3,libmio_tptr	
		ldi	YL,LOW(libmio_tram)
		ldi	YH,HIGH(libmio_tram)
		dec	tempreg3
		sbrc	tempreg3,7
		inc	tempreg3
		add	YL,tempreg3
		adc	YH,const_0
		ldi	XL,0x20
		st	Y,XL
		sts	libmio_tptr,tempreg3
libmio_akey_1a:	rjmp	libmio_akey_1		;loop
		
libmio_akey_13:	lds	tempreg3,libmio_tptr	
		cp	tempreg3,tempreg2
		brcc	libmio_akey_1a
		ldi	YL,LOW(libmio_tram)
		ldi	YH,HIGH(libmio_tram)
		add	YL,tempreg3
		adc	YH,const_0
		ldi	ZL,low(libmio_akdata*2)
		ldi	ZH,HIGH(libmio_akdata*2)
		add	ZL,tempreg4
		adc	ZH,const_0
		lpm	tempreg1,Z+
		st	Y+,tempreg1
		inc	tempreg3
		sts	libmio_tptr,tempreg3
		rjmp	libmio_akey_1				


;------------------------------------------------------------------------------
;num keyboard
;tempreg2=len
;------------------------------------------------------------------------------
libmio_nkey:	push	ZH			;save registers
		push	ZL
		push	YH
		push	YL
		push	XH
		push	XL
		push	tempreg3
		push	tempreg4
		clr	tempreg4
		
		clr	ctrl			;normal mode
		sts	libmio_channel,const_0	;output to screen
		sts	libmio_color,const_1	;set normal color
		sts	libmio_font,const_0	;set normal font
		ldi	YL,0
		ldi	YH,0
		ldi	ZL,127
		ldi	ZH,63
		rcall	libmio_fbox
		sts	libmio_color,const_0	;set inverse color
		ldi	XL,2
		ldi	XH,2
		rcall	libmio_gxy		
		ldi	ZL,LOW(libmio_tram+32)
		ldi	ZH,HIGH(libmio_tram+32)
		ldi	XL,20
libmio_nkey_0:	ld	tempreg1,Z+
		call	libmio_char
		dec	XL
		brne	libmio_nkey_0		
					
;text field		
		ldi	YL,4
		ldi	YH,13
		ldi	ZH,26
		ldi	ZL,6
		mul	ZL,tempreg2
		ldi	ZL,5
		add	ZL,r0
		rcall	libmio_fbox
;key field		
		ldi	YL,20
		ldi	YH,39
		ldi	ZL,105
		ldi	ZH,50
		rcall	libmio_fbox
		sts	libmio_tptr,const_0	;text len is 0
;draw text
libmio_nkey_1:	ldi	XL,5
		ldi	XH,15
		rcall	libmio_gxy
		sts	libmio_color,const_1	;set normal color
		ldi	ZL,LOW(libmio_tram)
		ldi	ZH,HIGH(libmio_tram)
		mov	XL,tempreg2
		clr	YL
		lds	YH,libmio_tptr
libmio_nkey_2:	ld	tempreg1,Z+
		cp	YL,YH
		brne	libmio_nkey_2a
		ldi	tempreg1,0x10		;pepper&salt
libmio_nkey_2a:	call	libmio_char
		inc	YL
		dec	XL
		brne	libmio_nkey_2
	
;keys
libmio_nkey_3:	ldi	ZL,low(libmio_nkdata*2)
		ldi	ZH,HIGH(libmio_nkdata*2)
libmio_nkey_4:	ldi	YL,0
libmio_nkey_5:	ldi	XL,21			;initial pos
		ldi	XH,40
		ldi	tempreg1,6
		mul	tempreg1,YL
		add	XL,r0
		rcall	libmio_gxy
		sts	libmio_color,const_1	;set normal color
		cp	YL,tempreg4
		brne	libmio_nkey_6
		sts	libmio_color,const_0	;set invers color
libmio_nkey_6:	lpm	tempreg1,Z+
		call	libmio_char
		inc	YL
		cpi	YL,14
		brne	libmio_nkey_5
		
libmio_nkey_7:	rcall	libmio_nokeys		;wait for key release
		rcall	libmio_waitkey		;wait for key
		cpi	tempreg1,0xed		;ESC?
		brne	libmio_nkey_8		;no
		clt				;set invalid
		rjmp	libmio_menu5_e		;end		

libmio_nkey_8:	cpi	tempreg1,0xea		;ENTER?
		brne	libmio_nkey_9		;no
		rjmp	libmio_nkey_10		;loop
		
libmio_nkey_9:	cpi	tempreg1,0xe2		;left
		brne	libmio_nkey_a
		cpi	tempreg4,0
		breq	libmio_nkey_7
		dec	tempreg4
		rjmp	libmio_nkey_3
		
libmio_nkey_a:	cpi	tempreg1,0xe3		;right
		brne	libmio_nkey_b
		cpi	tempreg4,13
		breq	libmio_nkey_7
		inc	tempreg4
		rjmp	libmio_nkey_3

libmio_nkey_b:	cpi	tempreg1,0xe4		;up
		brne	libmio_nkey_c
		clr	tempreg4
		rjmp	libmio_nkey_3

libmio_nkey_c:	ldi	tempreg4,13		;down
		rjmp	libmio_nkey_3
		
libmio_nkey_10:	
libmio_nkey_11:	cpi	tempreg4,13		;enter?
		brne	libmio_nkey_12		;no
		set				;set valid
		rjmp	libmio_menu5_e		;end

libmio_nkey_12:	cpi	tempreg4,12		;backspace?
		brne	libmio_nkey_13		;no
		lds	tempreg3,libmio_tptr	
		ldi	YL,LOW(libmio_tram)
		ldi	YH,HIGH(libmio_tram)
		dec	tempreg3
		sbrc	tempreg3,7
		inc	tempreg3
		add	YL,tempreg3
		adc	YH,const_0
		ldi	XL,0x20
		st	Y,XL
		sts	libmio_tptr,tempreg3
libmio_nkey_1a:	rjmp	libmio_nkey_1		;loop
		
libmio_nkey_13:	lds	tempreg3,libmio_tptr	
		cp	tempreg3,tempreg2
		brcc	libmio_nkey_1a
		ldi	YL,LOW(libmio_tram)
		ldi	YH,HIGH(libmio_tram)
		add	YL,tempreg3
		adc	YH,const_0
		ldi	ZL,low(libmio_nkdata*2)
		ldi	ZH,HIGH(libmio_nkdata*2)
		add	ZL,tempreg4
		adc	ZH,const_0
		lpm	tempreg1,Z+
		st	Y+,tempreg1
		inc	tempreg3
		sts	libmio_tptr,tempreg3
		rjmp	libmio_nkey_1				

;------------------------------------------------------------------------------
;copy flash text to tram+35
;------------------------------------------------------------------------------
libmio_catext:	push	ZH			;save registers
		push	ZL
		push	YH
		push	YL
		push	XH
		push	XL
		push	tempreg3
		push	tempreg4
		ldi	YL,LOW(libmio_tram+32)
		ldi	YH,HIGH(libmio_tram+32)
		ldi	tempreg3,21
libmio_catext1:	lpm	tempreg4,Z+
		st	Y+,tempreg4
		dec	tempreg3
		brne	libmio_catext1
		rjmp	libmio_menu5_e


;------------------------------------------------------------------------------
;clear alpha text
;------------------------------------------------------------------------------
libmio_clrtext:	push	ZH			;save registers
		push	ZL
		push	YH
		push	YL
		push	XH
		push	XL
		push	tempreg3
		push	tempreg4
		ldi	YL,LOW(libmio_tram)
		ldi	YH,HIGH(libmio_tram)
		ldi	tempreg3,32
		ldi	tempreg4,0x20		;space
libmio_cltext1:	st	Y+,tempreg4
		dec	tempreg3
		brne	libmio_cltext1
		rjmp	libmio_menu5_e

;------------------------------------------------------------------------------
;call alpha keyboard from Flash text
;------------------------------------------------------------------------------
libmio_alkb:	rcall	libmio_catext
		rcall	libmio_akey
		lds	tempreg2,libmio_tptr		
		ret

;------------------------------------------------------------------------------
;call num keyboard from Flash text
;------------------------------------------------------------------------------
libmio_nukb:	rcall	libmio_catext
		rcall	libmio_nkey
		lds	tempreg2,libmio_tptr		
		ret

						
;------------------------------------------------------------------------------
;data for alpha keyboard
;------------------------------------------------------------------------------
libmio_akdata:	.db	"0123456789+-*/=<>.,_"
		.db	"ABCDEFGHIJKLMNOPQRST"
		.db	"UVWXYZ #!$%&/()[]",0x3b,0x8c,0x8b

;------------------------------------------------------------------------------
;data for num keyboard
;------------------------------------------------------------------------------				
libmio_nkdata:	.db	"0123456789-.",0x8c,0x8b
																
 						
;-----------------------------------------------------------------------------
; draw 5 button icons from Z+ (ESC is always the same)
;-----------------------------------------------------------------------------
libmio_aframe:	push	ZL
		push	ZH
		sts	libmio_color,const_0
		sts	libmio_font,const_0
		clr	ctrl
		ldi	YL,LOW(libmio_vram)
		ldi	YH,HIGH(libmio_vram)
		ldi	XL,0xff
		ldi	XH,0
libmio_aframe1:	st	Y+,XL
		st	Y+,XL
		st	Y+,XL
		st	Y+,XL
		dec	XH
		brne	libmio_aframe1
		ldi	XL,0xf8
		sts	libmio_vram,XL
		sts	libmio_vram+1008,XL
		ldi	XL,0xfc
		sts	libmio_vram+16,XL
		sts	libmio_vram+992,XL		
		ldi	XL,0xfe
		sts	libmio_vram+32,XL
		sts	libmio_vram+976,XL			
		
		ldi	XL,0x1f
		sts	libmio_vram+15,XL
		sts	libmio_vram+1023,XL
		ldi	XL,0x3f
		sts	libmio_vram+31,XL
		sts	libmio_vram+1007,XL		
		ldi	XL,0x7f
		sts	libmio_vram+47,XL
		sts	libmio_vram+991,XL			
		
		ldi	YL,11		
		ldi	YH,10
		ldi	ZL,116
		ldi	ZH,61
		call	libmio_fbox			;clear inner box

		lds	XL,libmio_sysconf
		sbrc	XL,4
		rjmp	libmio_aframe3			;rotated		
				
;normal pos						
libmio_aframe2:	ldi	ZL,LOW(libmio_icons*2)		;ESC
		ldi	ZH,HIGH(libmio_icons*2)	
		ldi	XL,7				;ESC pos
		rcall	libmio_iconl
		
		pop	ZH				;restore pointer
		pop	ZL
		
		ldi	XL,45				;ENTER pos
		rcall	libmio_iconl
		ldi	XL,7				;UP pos
		rcall	libmio_iconr		
		ldi	XL,26				;LR pos
		rcall	libmio_iconr						
		ldi	XL,45				;DOWN pos
		rjmp	libmio_iconr					

		
libmio_aframe3:	ldi	ZL,LOW(libmio_icons*2)		;ESC
		ldi	ZH,HIGH(libmio_icons*2)	
		ldi	XL,7				;ESC pos
		rcall	libmio_iconr
		
		pop	ZH				;restore pointer
		pop	ZL
		
		ldi	XL,45				;ENTER pos
		rcall	libmio_iconr
		ldi	XL,7				;UP pos
		rcall	libmio_iconl		
		ldi	XL,26				;LR pos
		rcall	libmio_iconl						
		ldi	XL,45				;DOWN pos
		rjmp	libmio_iconl					
				

;-----------------------------------------------------------------------------
; draw 8*10 icon on line XL (left)
;-----------------------------------------------------------------------------
libmio_iconl:	ldi	XH,16
		mul	XL,XH
		ldi	YL,LOW(libmio_vram)
		ldi	YH,HIGH(libmio_vram)		
		add	YL,r0
		adc	YH,r1
		st	Y+,const_0
		adiw	YL,15
		
		st	Y+,const_0
		rcall	libmio_iconl_m		
		ldi	XH,10
libmio_iconl_1:	lpm	XL,Z+
		st	Y+,XL
		rcall	libmio_iconl_m
		dec	XH
		brne	libmio_iconl_1
		st	Y+,const_0
		rcall	libmio_iconl_m
		st	Y+,const_0
		ret		
		
libmio_iconl_m:	ld	XL,Y
		andi	XL,0xfe
		st	Y+,XL
		adiw	YL,14					
		ret
		
;-----------------------------------------------------------------------------
; draw 8*10 icon on line XL (right)
;-----------------------------------------------------------------------------
libmio_iconr:	ldi	XH,16
		mul	XL,XH
		ldi	YL,LOW(libmio_vram+15)
		ldi	YH,HIGH(libmio_vram+15)		
		add	YL,r0
		adc	YH,r1
		st	Y+,const_0
		adiw	YL,14

		rcall	libmio_iconr_m		
		st	Y+,const_0
		adiw	YL,14			
		ldi	XH,10
libmio_iconr_1:	rcall	libmio_iconr_m
		lpm	XL,Z+
		st	Y+,XL
		adiw	YL,14		
		dec	XH
		brne	libmio_iconr_1
		rcall	libmio_iconr_m		
		st	Y+,const_0
		adiw	YL,15
		st	Y+,const_0
		ret	
		
libmio_iconr_m:	ld	XL,Y
		andi	XL,0x7f
		st	Y+,XL
		ret	

;------------------------------------------------------------------------------
;menu border
;------------------------------------------------------------------------------
libmio_mbord:	push	ZL
		push	ZH
		push	XL
		clr	ctrl			;normal mode
		sts	libmio_channel,const_0	;output to screen
		sts	libmio_font,const_0	;normal font
		sts	libmio_color,const_1	;normal
		libmio_clrscr
		ldi	YL,0
		ldi	YH,4
		ldi	ZL,127
		ldi	ZH,63
		libmio_box
		clr	XH
		pop	XL
		pop	ZH
		pop	ZL
		sts	libmio_color,const_0	;inverse
		call	libmio_gxy		;output text
		call	libmio_orom
		sts	libmio_color,const_1	;normal				
		ret
		
;------------------------------------------------------------------------------
;only border
;------------------------------------------------------------------------------
libmio_obord:	push	ZL
		push	ZH
		clr	ctrl			;normal mode
		sts	libmio_channel,const_0	;output to screen
		sts	libmio_font,const_0	;normal font
		sts	libmio_color,const_1	;normal
		libmio_clrscr
		ldi	YL,0
		ldi	YH,4
		ldi	ZL,127
		ldi	ZH,63
		libmio_box
		sts	libmio_color,const_0	;inverse
		pop	ZH
		pop	ZL		
		ret		