;################################################################################
;#										#
;# libmio - multi i/o for ATMega 644 version 0.40				#
;# macro definitions								#
;# copyright (c) 2005-2008 Joerg Wolfram (joerg@jcwolfram.de)			#
;#										#
;# This library is free software; you can redistribute it and/or		#
;# modify it under the terms of the GNU Lesser General Public			#
;# License as published by the Free Software Foundation; either			#
;# version 2 of the License, or (at your option) any later version.		#
;#										#
;# This library is distributed in the hope that it will be useful,		#
;# but WITHOUT ANY WARRANTY; without even the implied warranty of		#
;# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	See the GNU		#
;# Lesser General Public License for more details.				#
;#										#
;# You should have received a copy of the GNU Lesser General Public		#
;# License along with this library; if not, write to the			#
;# Free Software Foundation, Inc., 59 Temple Place - Suite 330,			#
;# Boston, MA 02111-1307, USA.							#
;#										#
;################################################################################

.macro libmio_vint
    jmp	libmio_isr
.endm

.macro libmio_init
    call	libmio_init
.endm

.macro libmio_outchar
    call	libmio_char
.endm

.macro libmio_outcomma
    call	libmio_comma
.endm

.macro libmio_outspace
    call	libmio_space
.endm

.macro libmio_waitkey
    .set	use_libmio_waitkey = 1
    .set	libmio_ps2key = 1
    call	libmio_waitkey
.endm

.macro libmio_nokey
    .set	use_libmio_nokey = 1
    .set	libmio_ps2key = 1
    call	libmio_nokey
.endm

.macro libmio_nokeys
    .set	use_libmio_nokeys = 1
    .set	libmio_ps2key = 1
    call	libmio_nokeys
.endm

.macro libmio_cursor
    .set	use_libmio_cursor = 1
    .set	libmio_ps2key = 1
    rcall	libmio_cursor
.endm

.macro libmio_ecursor
    .set	use_libmio_ecursor = 1
    .set	use_libmio_editor_mode = 1
    .set	libmio_ps2key = 1
    rcall	libmio_ecursor
.endm

.macro libmio_ncursor
    .set	use_libmio_ncursor = 1
    .set	use_libmio_editor_mode = 1
    .set	libmio_ps2key = 1
    rcall	libmio_ncursor
.endm

.macro libmio_freecur
    .set	use_libmio_cursor = 1
    .set	libmio_ps2key = 1
    rcall	libmio_cur1
.endm

.macro libmio_outdez
    .set	use_libmio_outd = 1
    call	libmio_outd
.endm

.macro libmio_outhex
    .set	use_libmio_outh = 1
    call	libmio_outh
.endm

.macro libmio_clrscr
    call	libmio_clr
.endm

.macro libmio_fillchar
    rcall	libmio_fill
.endm

.macro libmio_ramtext
    .set	use_libmio_oram = 1
    call	libmio_oram
.endm

.macro libmio_romtext
    .set	use_libmio_orom = 1
    call	libmio_orom
.endm

.macro libmio_thistext
    .set	use_libmio_othis = 1
    .set	use_libmio_gotoxy = 1
    call	libmio_othis
.endm

.macro libmio_xztext
    .set	use_libmio_othis = 1
    .set	use_libmio_gotoxy = 1
    call	libmio_orxy
.endm

.macro libmio_mtext
    .set	use_libmio_mtext = 1
    rcall	libmio_mtext
.endm

.macro libmio_newline
    .set	use_libmio_newline = 1
    call	libmio_newline
.endm

.macro libmio_gotoxy
    .set	use_libmio_gotoxy = 1
    call	libmio_gxy
.endm

.macro libmio_plot
    .set	use_libmio_plot = 1
    call	libmio_plot
.endm

.macro libmio_box
    .set	use_libmio_plot = 1
    .set	use_libmio_box = 1
    call	libmio_box
.endm

.macro libmio_cbox
    .set	use_libmio_cbox = 1
    rcall	libmio_cbox
.endm

.macro libmio_ibox
    .set	use_libmio_ibox = 1
    rcall	libmio_ibox
.endm

.macro libmio_wbox
    .set	use_libmio_wbox = 1
    rcall	libmio_wbox
.endm

.macro libmio_whbox
    .set	use_libmio_wbox = 1
    .set	use_libmio_whbox = 1
    rcall	libmio_whbox
.endm

.macro libmio_wh2box
    .set	use_libmio_wbox = 1
    .set	use_libmio_whbox = 1
    rcall	libmio_wh2box
.endm

.macro libmio_fbox
    .set	use_libmio_plot = 1
    .set	use_libmio_fbox = 1
    call	libmio_fbox
.endm

.macro libmio_circle
    .set	use_libmio_circle = 1
    call	libmio_circle
.endm

.macro libmio_fcircle
    .set	use_libmio_circle = 1
    call	libmio_fcircle
.endm

.macro libmio_draw
    .set	use_libmio_plot = 1
    .set	use_libmio_draw = 1
    call	libmio_draw
.endm

.macro libmio_sync
    .set	use_libmio_sync = 1
    call	libmio_sync
.endm

.macro libmio_note
    .set	use_libmio_note = 1
    call	libmio_note
.endm

.macro libmio_calc
    rcall	libmio_calc
.endm

.macro libmio_ecalc
    rcall	libmio_ecalc
.endm

.macro libmio_pser
    .set	use_libmio_serial = 1
    .set	use_libmio_pser = 1
    call	libmio_pser
.endm

.macro libmio_gser
    .set	use_libmio_serial = 1
    .set	use_libmio_gser = 1
    call	libmio_gser
.endm

.macro libmio_gserb
    .set	use_libmio_serial = 1
    .set	use_libmio_gser = 1
    call	libmio_gserb
.endm

.macro libmio_ppar
.endm

.macro libmio_setcolor
    call	libmio_setcol
.endm

.macro libmio_setnorm
    sts	libmio_color,const_1
.endm

.macro libmio_setinv
    sts	libmio_color,const_0
.endm

.macro libmio_setborder
.endm

.macro libmio_screenshot
    .set	use_libmio_screenshot = 1
    rcall	libmio_scrs
.endm

.macro libmio_chpump
    .set	use_libmio_chp = 1
    rcall	libmio_chp
.endm

.macro libmio_cconv
    .set	use_libmio_cconv = 1
    rcall	libmio_cconv
.endm

.macro libmio_pconv
    .set	use_libmio_pconv = 1
    rcall	libmio_pconv
.endm

.macro libmio_gchar
    .set	use_libmio_gchar = 1
    rcall	libmio_pconv
.endm

.macro libmio_vcur
    .set	use_libmio_vcur = 1
    rcall	libmio_vcur
.endm

.macro libmio_random
    .set	use_libmio_psrg = 1
    call	libmio_psrg
.endm

.macro libmio_bcopy
    .set	use_libmio_bcopy = 1
    call	libmio_bcopy
.endm

.macro libmio_sysconf
    call	libmio_setconf
.endm

.macro libmio_copyentry
    call	libmio_copyent
.endm

.macro libmio_copymenu
    call	libmio_copyram
.endm

.macro libmio_menu5
    call	libmio_menu5
.endm

.macro libmio_imenu8
    call	libmio_menu8
.endm

.macro libmio_imenu4
    call	libmio_menu4
.endm

.macro libmio_menu8icons
    rcall	libmio_dr8i
.endm

.macro libmio_menu4icons
    call	libmio_dr4i
.endm

.macro libmio_menuheadf
    call	libmio_mheadf
.endm

.macro libmio_akeyb
    call	libmio_akey
.endm

.macro libmio_flakeyb
    call	libmio_alkb
.endm

.macro libmio_flnkeyb
    call	libmio_nukb
.endm

.macro libmio_newtext
    call	libmio_clrtext
    call	libmio_alkb
.endm

.macro libmio_newnum
    call	libmio_clrtext
    call	libmio_nukb
.endm

.macro libmio_serftext
    call	libmio_fsert
.endm

.macro libmio_appframe
    call	libmio_aframe
.endm

.macro libmio_mborder
    call	libmio_mbord
.endm

.macro libmio_oborder
    call	libmio_obord
.endm;################################################################################
;#										#
;# libi2c - I2C library for ATMega controllers 					#
;# copyright (c) 2007-2008 Joerg Wolfram (joerg@jcwolfram.de)			#
;#										#
;# This library is free software; you can redistribute it and/or		#
;# modify it under the terms of the GNU Lesser General Public			#
;# License as published by the Free Software Foundation; either			#
;# version 2 of the License, or (at your option) any later version.		#
;#										#
;# This library is distributed in the hope that it will be useful,		#
;# but WITHOUT ANY WARRANTY; without even the implied warranty of		#
;# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	See the GNU		#
;# Lesser General Public License for more details.				#
;#										#
;# You should have received a copy of the GNU Lesser General Public		#
;# License along with this library; if not, write to the			#
;# Free Software Foundation, Inc., 59 Temple Place - Suite 330,			#
;# Boston, MA 02111-1307, USA.							#
;#										#
;################################################################################

.macro libi2c_init
    call	libi2c_initl
.endm

.macro libi2c_read
    .set	use_libi2c_read = 1
    call	libi2c_read
.endm

.macro libi2c_start
    call	libi2c_start
.endm

.macro libi2c_stop
    call	libi2c_stop
.endm

.macro libi2c_rbyte
    call	libi2c_rbyte
.endm

.macro libi2c_rbyten
    call	libi2c_rbyten
.endm

.macro libi2c_wbyte
    call	libi2c_wbyte
.endm


.macro libi2c_write
    .set	use_libi2c_write = 1
    call	libi2c_write
.endm

.macro libi2c_rlm75
    .set	use_libi2c_lm75 = 1
    call	libi2c_rlm75
.endm

.macro libi2c_rtc3232_read_time
    .set	use_libi2c_rtc32 = 1
    call	libi2c_r32rt
.endm

.macro libi2c_rtc3232_read_date
    .set	use_libi2c_rtc32 = 1
    rcall	libi2c_r32rd
.endm

.macro libi2c_rtc3232_write_time
    .set	use_libi2c_rtc32 = 1
    call	libi2c_r32wt
.endm

.macro libi2c_rtc3232_write_date
    .set	use_libi2c_rtc32 = 1
    call	libi2c_r32wd
.endm

.macro libi2c_rtc3232_read_alarm
    .set	use_libi2c_rtc32 = 1
    call	libi2c_r32ra
.endm

.macro libi2c_rtc3232_write_alarm
    .set	use_libi2c_rtc32 = 1
    call	libi2c_r32wa
.endm

.macro libi2c_rtc3232_read_status
    .set	use_libi2c_rtc32 = 1
    call	libi2c_r32ras
.endm

.macro libi2c_rtc3232_write_status
    .set	use_libi2c_rtc32 = 1
    call	libi2c_r32was
.endm
;################################################################################
;#										#
;# libdfl - Dataflash routines							#
;# copyright (c) 2007-2008 Joerg Wolfram (joerg@jcwolfram.de)			#
;#										#
;# This library is free software; you can redistribute it and/or		#
;# modify it under the terms of the GNU Lesser General Public			#
;# License as published by the Free Software Foundation; either			#
;# version 2 of the License, or (at your option) any later version.		#
;#										#
;# This library is distributed in the hope that it will be useful,		#
;# but WITHOUT ANY WARRANTY; without even the implied warranty of		#
;# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	See the GNU		#
;# Lesser General Public License for more details.				#
;#										#
;# You should have received a copy of the GNU Lesser General Public		#
;# License along with this library; if not, write to the			#
;# Free Software Foundation, Inc., 59 Temple Place - Suite 330,			#
;# Boston, MA 02111-1307, USA.							#
;#										#
;################################################################################

.macro libdfl_format
    call	libdfl_format
.endm

.macro libdfl_create
    call	libdfl_create
.endm

.macro libdfl_delete
    call	libdfl_del
.endm

.macro libdfl_read
    call	libdfl_read
.endm

.macro libdfl_write
    call	libdfl_write
.endm

.macro libdfl_free
    call	libdfl_cfree
.endm

.macro libdfl_size
    call	libdfl_size
.endm

.macro libdfl_maxpage
    call	libdfl_maxpage
.endm

.macro libdfl_checkformat
    call	libdfl_cif
.endm

.macro libdfl_gettype
    call	libdfl_ghead
    call	libdfl_gtype
.endm

.macro libdfl_gword
    call	libdfl_gdword
.endm

.macro libdfl_readraw
    call	libdfl_bread
    call	libdfl_rdbuf
.endm

.macro libdfl_writeraw
    call	libdfl_wrbuf
    call	libdfl_bwrite
.endm

;################################################################################
;#										#
;# libgps - NMEA read library							#
;# copyright (c) 2008 Joerg Wolfram (joerg@jcwolfram.de)			#
;#										#
;# This library is free software; you can redistribute it and/or		#
;# modify it under the terms of the GNU Lesser General Public			#
;# License as published by the Free Software Foundation; either			#
;# version 2 of the License, or (at your option) any later version.		#
;#										#
;# This library is distributed in the hope that it will be useful,		#
;# but WITHOUT ANY WARRANTY; without even the implied warranty of		#
;# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	See the GNU		#
;# Lesser General Public License for more details.				#
;#										#
;# You should have received a copy of the GNU Lesser General Public		#
;# License along with this library; if not, write to the			#
;# Free Software Foundation, Inc., 59 Temple Place - Suite 330,			#
;# Boston, MA 02111-1307, USA.							#
;#										#
;################################################################################

.macro libgps_rrmc
    call	libgps_getrmc
.endm


.macro libgps_dummy
    nop
.endm
;################################################################################
;#										#
;# libeep - EEPRO R/W library for AVR controllers 				#
;# copyright (c) 2007-2008 Joerg Wolfram (joerg@jcwolfram.de)			#
;#										#
;# This library is free software; you can redistribute it and/or		#
;# modify it under the terms of the GNU Lesser General Public			#
;# License as published by the Free Software Foundation; either			#
;# version 2 of the License, or (at your option) any later version.		#
;#										#
;# This library is distributed in the hope that it will be useful,		#
;# but WITHOUT ANY WARRANTY; without even the implied warranty of		#
;# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	See the GNU		#
;# Lesser General Public License for more details.				#
;#										#
;# You should have received a copy of the GNU Lesser General Public		#
;# License along with this library; if not, write to the			#
;# Free Software Foundation, Inc., 59 Temple Place - Suite 330,			#
;# Boston, MA 02111-1307, USA.							#
;#										#
;################################################################################

.macro libeep_read
    call	libeep_read
.endm

.macro libeep_write
    call	libeep_write
.endm

.macro libeep_get
    rcall	libeep_get
.endm

.macro libeep_put
    call	libeep_put
.endm

