;################################################################################
;#										#
;# avr-chipbasic2M - mobile single chip basic computer with ATmega644		#
;# API										#
;# copyright (c) 2008 Joerg Wolfram (joerg@jcwolfram.de)			#
;#										#
;#										#
;# This program is free software; you can redistribute it and/or		#
;# modify it under the terms of the GNU General Public License			#
;# as published by the Free Software Foundation; either version 2		#
;# of the License, or (at your option) any later version.			#
;#										#
;# This program is distributed in the hope that it will be useful,		#
;# but WITHOUT ANY WARRANTY; without even the implied warranty of		#
;# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.See the GNU		#
;# General Public License for more details.					#
;#										#
;# You should have received a copy of the GNU General Public			#
;# License along with this library; if not, write to the			#
;# Free Software Foundation, Inc., 59 Temple Place - Suite 330,			#
;# Boston, MA 02111-1307, USA.							#
;#										#
;################################################################################		
		
;-----------------------------------------------------------------------------
; jump table 
;-----------------------------------------------------------------------------
api_table:	jmp	api_getvram		;get vram address to Y
		jmp	api_getvmodes		;get available video modes to r16
		jmp	api_getvmode		;get recent video mode to r16
		jmp	api_setvmode		;set video mode from r16
		jmp	api_getram		;get libmio sys ram to Y
		jmp	libmio_clr		;clear screen
		jmp	libmio_char		;output char from r20
		jmp	libmio_newline		;output newline
		jmp	libmio_gxy		;set position to XL=X XH=Y
		jmp	api_setcolor		;set color to r16
		

api_getvram:	ldi	YL,LOW(libmio_vram)
		ldi	YH,HIGH(libmio_vram)
		ret
		
api_getvmodes:	ldi	r16,0x20
		ret
		
api_getvmode:	ldi	r16,5				
api_setvmode:	ret

api_getram:	ldi	YL,LOW(libmio_ram)
		ldi	YH,HIGH(libmio_ram)
		ret
		
api_setcolor:	andi	r16,0x01
		sts	libmio_color,r16
		ret
				