;################################################################################
;#										#
;# avr-chipbasic2M - mobile single chip basic computer with ATmega644		#
;# configure menu								#
;# copyright (c) 2008 Joerg Wolfram (joerg@jcwolfram.de)			#
;#										#
;#										#
;# This program is free software; you can redistribute it and/or		#
;# modify it under the terms of the GNU General Public License			#
;# as published by the Free Software Foundation; either version 2		#
;# of the License, or (at your option) any later version.			#
;#										#
;# This program is distributed in the hope that it will be useful,		#
;# but WITHOUT ANY WARRANTY; without even the implied warranty of		#
;# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.See the GNU		#
;# General Public License for more details.					#
;#										#
;# You should have received a copy of the GNU General Public			#
;# License along with this library; if not, write to the			#
;# Free Software Foundation, Inc., 59 Temple Place - Suite 330,			#
;# Boston, MA 02111-1307, USA.							#
;#										#
;################################################################################


;------------------------------------------------------------------------------
;configure system
;------------------------------------------------------------------------------
conf_menu:	clr	tempreg2
		call	mem_getconf
		ldi	XL,19
		ldi	ZL,LOW(text_conf_1*2)	;text key turns
		ldi	ZH,HIGH(text_conf_1*2)				
		libmio_mborder
		
conf_menu_00:	ldi	YL,LOW(libmio_mram+20)
		ldi	YH,HIGH(libmio_mram+20)		
		lds	tempreg3,libmio_sysconf
	
				
conf_menu_01:	ldi	ZL,LOW(configdata_vid*2)
		ldi	ZH,HIGH(configdata_vid*2)
		sbrc	tempreg3,0
		adiw	ZL,18
		libmio_copyentry

conf_menu_02:	ldi	ZL,LOW(configdata_snd*2)
		ldi	ZH,HIGH(configdata_snd*2)
		sbrc	tempreg3,3
		adiw	ZL,18
		libmio_copyentry
		
conf_menu_03:	ldi	ZL,LOW(configdata_spi*2)
		ldi	ZH,HIGH(configdata_spi*2)
		sbrs	tempreg3,1			;skip if 156KHz
		adiw	ZL,18
		libmio_copyentry

conf_menu_04:	ldi	ZL,LOW(configdata_i2c*2)
		ldi	ZH,HIGH(configdata_i2c*2)
		sbrc	tempreg3,2
		adiw	ZL,18
		libmio_copyentry

		
conf_menu_05:	ldi	ZL,LOW(configdata_ser*2)
		ldi	ZH,HIGH(configdata_ser*2)
		lsr	tempreg3
		andi	tempreg3,0x70
		add	ZL,tempreg3
		adc	ZH,const_0
		lsr	tempreg3
		lsr	tempreg3
		lsr	tempreg3
		add	ZL,tempreg3
		adc	ZH,const_0
		libmio_copyentry
			

conf_menu_20:	clt
		ldi	r19,5
		libmio_menu5
		lds	XL,libmio_sysconf
		cpi	tempreg1,0xed
		brne	conf_menu_21
		ret				;return to main menu

conf_menu_21:	cpi	tempreg1,0xea
		brne	conf_menu_22
		sts	libmio_sysconf,XL
		call	mem_setconf
		jmp	0
		
conf_menu_22:	cpi	tempreg2,0		;sel vid
		brne	conf_menu_23
		ldi	XH,0x01
		eor	XL,XH
		rjmp	conf_menu_l

conf_menu_23:	cpi	tempreg2,1		;sel snd
		brne	conf_menu_24
		ldi	XH,0x08
		eor	XL,XH
		rjmp	conf_menu_l

conf_menu_24:	cpi	tempreg2,2		;sel spi
		brne	conf_menu_25
		ldi	XH,0x02
		eor	XL,XH
		rjmp	conf_menu_l

conf_menu_25:	cpi	tempreg2,3		;sel I2c
		brne	conf_menu_26
		ldi	XH,0x04
		eor	XL,XH
		rjmp	conf_menu_l
				
conf_menu_26:	cpi	tempreg1,0xe2
		brne	conf_menu_27
		ldi	XH,0x20
		sub	XL,XH
		rjmp	conf_menu_l

conf_menu_27:	ldi	XH,0x20
		add	XL,XH
		
conf_menu_l:	sts	libmio_sysconf,XL
		libmio_nokey
		rjmp	conf_menu_00		
				



					