;################################################################################
;#										#
;# avr-chipbasic2m - mobile single chip basic computer with ATmega644		#
;# gps2 functions								#
;# copyright (c) 2008 Joerg Wolfram (joerg@jcwolfram.de)			#
;#										#
;#										#
;# This program is free software; you can redistribute it and/or		#
;# modify it under the terms of the GNU General Public License			#
;# as published by the Free Software Foundation; either version 2		#
;# of the License, or (at your option) any later version.			#
;#										#
;# This program is distributed in the hope that it will be useful,		#
;# but WITHOUT ANY WARRANTY; without even the implied warranty of		#
;# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.See the GNU		#
;# General Public License for more details.					#
;#										#
;# You should have received a copy of the GNU General Public			#
;# License along with this library; if not, write to the			#
;# Free Software Foundation, Inc., 59 Temple Place - Suite 330,			#
;# Boston, MA 02111-1307, USA.							#
;#										#
;################################################################################
;------------------------------------------------------------------------------
;main screen mask
;------------------------------------------------------------------------------
gps2_main:	ldi	ZL,LOW(libmio_icons*2+410)
		ldi	ZH,HIGH(libmio_icons*2+410)
		libmio_appframe
		libmio_thistext		
		.db 0,10,"-GPS",0,0
		
		ldi	YL,LOW(bas_array)
		ldi	YH,HIGH(bas_array)
		ldi	XL,64
		ldi	XH,'-'
gps2_main_i1:	st	Y+,XH
		dec	XL
		brne	gps2_main_i1
		ldi	YL,LOW(bas_array)
		ldi	YH,HIGH(bas_array)
		ldi	XL,0x30
		std	Y+8,const_0
		std	Y+9,const_0
		std	Y+21,const_0
		std	Y+34,const_0		
		std	Y+38,const_0
		std	Y+39,XL
		std	Y+40,XL
		std	Y+41,XL
		std	Y+42,const_0
		std	Y+51,const_0

			
		
		ldi	YL,LOW(bas_array)
		ldi	YH,HIGH(bas_array)
		ldi	XL,64
		ldi	XH,'-'
gps2_main_i2:	st	Y+,XH
		dec	XL
		brne	gps2_main_i2
		ldi	YL,LOW(bas_array)
		ldi	YH,HIGH(bas_array)
		ldi	XL,0x30
		std	Y+8,const_0
		std	Y+9,const_0
		std	Y+21,const_0
		std	Y+34,const_0		
		std	Y+38,const_0
		std	Y+39,XL
		std	Y+40,XL
		std	Y+41,XL
		std	Y+42,const_0
		std	Y+51,const_0

		libmio_setnorm			
		ldi	YL,10			;box for angle arrows
		ldi	YH,31
		ldi	ZL,117
		ldi	ZH,63
		libmio_fbox
		sts	libmio_font,const_1				
		
		ldi	XL,12
		ldi	XH,11
		ldi	ZL,LOW(gps2_text_1*2)	;text pointer
		ldi	ZH,HIGH(gps2_text_1*2)
		libmio_xztext				
		ldi	XL,12
		ldi	XH,21
		ldi	ZL,LOW(gps2_text_2*2)	;text pointer
		ldi	ZH,HIGH(gps2_text_2*2)
		libmio_xztext	
				
		libmio_setinv
		ldi	XL,24
		ldi	XH,58
		ldi	ZL,LOW(gps2_text_3*2)	;text pointer
		ldi	ZH,HIGH(gps2_text_3*2)
		libmio_xztext			
		
		libmio_thistext		
		.db 11,42,0,0	

;get target data		
		ldi	YL,LOW(2044)		;target selector (0-3)
		ldi	YH,HIGH(2044)
		libeep_read			;get value
		andi	tempreg1,0x03		;limit
		ldi	tempreg2,32		;bytes per entry
		ldi	YL,LOW(1664)
		ldi	YH,HIGH(1664)
		mul	tempreg1,tempreg2
		add	YL,r0
		adc	YH,r1
		ldi	XL,LOW(bas_array+200)
		ldi	XH,HIGH(bas_array+200)
		ldi	tempreg2,32
gps2_main_02:	libeep_read
		st	X+,tempreg1
		dec	tempreg2
		brne	gps2_main_02

		sts	libmio_font,const_0	;normal font
		sts	libmio_color,const_1		
		ldi	XL,LOW(bas_array+200)
		ldi	XH,HIGH(bas_array+200)
		ldi	tempreg2,12
gps2_main_03:	ld	tempreg1,X+
		libmio_outchar
		dec	tempreg2
		brne	gps2_main_03				
		
gps2_main_20:	sts	libmio_font,const_0		
		ldi	XL,0x00	
		libmio_setcolor	
		libmio_nokey
		
gps2_main_21:	ldi	YL,LOW(bas_array)
		ldi	YH,HIGH(bas_array)
		libgps_rrmc			;get RMC data		
		ldi	XL,0x00
		libmio_setcolor
		clr	XH
		ldi	XL,10
		libmio_gotoxy
		lds	XL,bas_array+9
		ldi	tempreg1,'?'
		sbrc	XL,0
		ldi	tempreg1,'*'
		libmio_outchar
		sts	libmio_font,const_1	;small font
				
;output time		
		ldi	XL,40
		ldi	XH,2
		libmio_gotoxy						
		ldi	ZL,LOW(bas_array)
		ldi	ZH,HIGH(bas_array)
		libmio_ramtext
;output date		
		ldi	XL,80
		ldi	XH,2
		libmio_gotoxy						
		ldi	ZL,LOW(bas_array+43)
		ldi	ZH,HIGH(bas_array+43)
		libmio_ramtext

		sts	libmio_font,const_0	;normal font
		ldi	XL,0x01			;set normal
		libmio_setcolor					

		libmio_thistext		
		.db 21,42,0,0					
		rcall	gps2_ddc		;distance calculation
		lds	XL,bas_array+154	;LOW
		lds	XH,bas_array+155	;HIGH	
		rcall	gps2_round		;round to 2 significant digits	

		
gps2_main_40:	lds	tempreg4,bas_array+153	;factor
		cpi	tempreg4,0
		brne	gps2_main_41
		ldi	ctrl,0x2e		
		libmio_outdez
		libmio_thistext
		.db	255," m  ",0
		rjmp	gps2_main_50
		
gps2_main_41:	cpi	tempreg4,1
		brne	gps2_main_42
		ldi	ctrl,0x1e		
		libmio_outdez
		libmio_thistext
		.db	255," m  ",0
		rjmp	gps2_main_50	
			
gps2_main_42:	cpi	tempreg4,2
		brne	gps2_main_43
		ldi	ctrl,0x0e		
		libmio_outdez
		libmio_thistext
		.db	255," m  ",0
		rjmp	gps2_main_50			
		
gps2_main_43:	cpi	tempreg4,3
		brne	gps2_main_44
		ldi	ctrl,0x2e		
		libmio_outdez
		libmio_thistext
		.db	255," km ",0
		rjmp	gps2_main_50				
	
gps2_main_44:	cpi	tempreg4,4
		brne	gps2_main_45
		ldi	ctrl,0x1e		
		libmio_outdez
		libmio_thistext
		.db	255," km ",0
		rjmp	gps2_main_50				

gps2_main_45:	ldi	ctrl,0x0e		
		libmio_outdez
		libmio_thistext
		.db	255," km ",0

gps2_main_50:										
					
;output course arrow		
		ldi	XL,19			;offset X
		ldi	XH,32
		call	gps_arrow
											
;output target arrow		
		lds	tempreg1,bas_array+40	;*1
		subi	tempreg1,0x30
		mov	tempreg5,tempreg1
		
		lds	tempreg1,bas_array+39	;*10
		subi	tempreg1,0x30
		mov	tempreg6,tempreg1
				
		lds	XL,bas_array+156
		rcall	gps2_wxl
		
		ldi	XL,81			;offset X
		ldi	XH,32		
		call	gps_arrow		


		lds	XH,bas_array+156	;XH=target dir
		ldi	XL,10
		mul	XL,tempreg6
		mov	XL,r0
		add	XL,tempreg5		;XL=course
		
		sub	XH,XL			;difference	
		brcc	gps2_main_51
		ldi	XL,36
		add	XH,XL
gps2_main_51:	mov	XL,XH

gps2_main_52:	rcall	gps2_wxl
		
		ldi	XL,50			;offset X
		ldi	XH,32		
		call	gps_arrow
		call	gps_cspeed
		brts	gps2_main_sv1
				
		ldi	XL,31			;offset X
		ldi	XH,44
		sts	libmio_color,const_1
		sts	libmio_bcsrcx,XL
		sts	libmio_bcsrcy,XH
		ldi	XL,6				;radius
		sts	libmio_bcdx,XL
		sts	libmio_bcdy,XL
		libmio_fcircle				;clear area
		ldi	XL,62			;offset X
		ldi	XH,44
		sts	libmio_bcsrcx,XL
		sts	libmio_bcsrcy,XH
		libmio_fcircle				;clear area
				
gps2_main_sv1:		
		
		
		
		lds	XL,libmio_keycode
		cpi	XL,0xed			;ESC
		brne	gps2_main_61
		ret

gps2_main_61:	cpi	XL,0xea			;ENTER=file menu
		brne	gps2_main_62
		rcall	gps2_fmenu
		rjmp	gps2_main
		
gps2_main_62:	cpi	XL,0xe2			;left=menu
		brne	gps2_main_63
		rjmp	gps_main
		
gps2_main_63:	cpi	XL,0xe3			;right=menu
		brne	gps2_main_64
		rjmp	gps3_main
		
gps2_main_64:	cpi	XL,0xe4			;up=next target
		brne	gps2_main_20x			
		rcall	gps2_next
		rjmp	gps2_main
gps2_main_20x:	rjmp	gps2_main_20		
		
		
;------------------------------------------------------------------------------
;FILE MENU
;------------------------------------------------------------------------------
gps2_fmenu:	clr	tempreg2

gps2_fmenu_re:	ldi	ZL,LOW(menudata_gps2*2)
		ldi	ZH,HIGH(menudata_gps2*2)
		libmio_copymenu
		
gps2_fmenu_1:	set
		ldi	r19,3
		libmio_menu5

gps2_fmenu_3:	cpi	tempreg1,0xed			;ESC
		brne	gps2_fmenu_4
		ret
		
gps2_fmenu_4:	cpi	tempreg1,0xea			;ENTER
		brne	gps2_fmenu_1
		
		cpi	tempreg2,0			;select target
		brne	gps2_fmenu_5
		rcall	gps2_selentry
		ldi	tempreg2,0
		rjmp	gps2_fmenu_re		
			

gps2_fmenu_5:	cpi	tempreg2,1			;store recent 
		brne	gps2_fmenu_6
		lds	XL,bas_array+9
		sbrc	XL,0
		rcall	gps2_setentry
		ldi	tempreg2,1
		rjmp	gps2_fmenu_re			

gps2_fmenu_6:	cpi	tempreg2,2			;input ccord
		brne	gps2_fmenu_1
		rcall	gps2_manentry
		ldi	tempreg2,2
		rjmp	gps2_fmenu_re			

;------------------------------------------------------------------------------
;select entry
;------------------------------------------------------------------------------				
gps2_selentry:	ldi	ZL,LOW(gps2_ftext1*2)		;text
		ldi	ZH,HIGH(gps2_ftext1*2)
		rcall	gps2_sel4
		mov	tempreg1,tempreg2
		andi	tempreg1,0x03
		ldi	YL,LOW(2044)			;EE entry pos
		ldi	YH,HIGH(2044)			
		libeep_write
		ret


;------------------------------------------------------------------------------
;next entry
;------------------------------------------------------------------------------				
gps2_next:	ldi	YL,LOW(2044)			;EE entry pos
		ldi	YH,HIGH(2044)
		libeep_read
		inc	tempreg1			;+1
		andi	tempreg1,0x03	
		ldi	YL,LOW(2044)			;EE base
		ldi	YH,HIGH(2044)			
		libeep_write
		ret		
		
				
;------------------------------------------------------------------------------
;set entry from recent pos
;------------------------------------------------------------------------------				
gps2_setentry:	ldi	ZL,LOW(gps2_ftext2*2)	;text
		ldi	ZH,HIGH(gps2_ftext2*2)	
		rcall	gps2_sel4
		cpi	tempreg1,0xed
		brne	gps2_setentry1
		ret

gps2_setentry1:	sts	bas_array+161,tempreg2	;which to modify

		ldi	ZL,LOW(gps2_ntext1*2)
		ldi	ZH,HIGH(gps2_ntext1*2)
		ldi	tempreg2,12
		libmio_newtext	
		brtc	gps2_setent_e		;skip if esc
		ldi	ZL,LOW(libmio_tram)
		ldi	ZH,HIGH(libmio_tram)
		ldi	YL,LOW(1664)
		ldi	YH,HIGH(1664)
		lds	tempreg2,bas_array+161
		andi	tempreg2,0x03
		ldi	tempreg1,32
		mul	tempreg1,tempreg2
		add	YL,r0
		adc	YH,r1

		ldi	XL,12
gps2_setent_01:	ld	tempreg1,Z+		
		libeep_write
		dec	XL
		brne	gps2_setent_01

		ldi	ZL,LOW(bas_array+10)
		ldi	ZH,HIGH(bas_array+10)
		
		ldi	tempreg1,0x30		;lat100 is always zero				
		libeep_write
		ld	tempreg1,Z+
		libeep_write
		ld	tempreg1,Z+
		libeep_write
		adiw	ZL,1
		ldi	XL,6
		
gps2_setent_02:	ld	tempreg1,Z+
		libeep_write		
		dec	XL
		brne	gps2_setent_02
		
		adiw	ZL,1
		ld	tempreg1,Z+
		libeep_write		
		
		ldi	ZL,LOW(bas_array+22)
		ldi	ZH,HIGH(bas_array+22)
		
		ldi	XL,3
gps2_setent_03:	ld	tempreg1,Z+			
		libeep_write
		dec	XL
		brne	gps2_setent_03

		adiw	ZL,1			;skip separator
		ldi	XL,6
		
gps2_setent_04:	ld	tempreg1,Z+
		libeep_write		
		dec	XL
		brne	gps2_setent_04					
		
		adiw	ZL,1
		ld	tempreg1,Z+
		libeep_write		
				
gps2_setent_e:	ret		


;------------------------------------------------------------------------------
;set entry manual
;------------------------------------------------------------------------------				
gps2_manentry:	ldi	ZL,LOW(gps2_ftext3*2)	;text
		ldi	ZH,HIGH(gps2_ftext3*2)		
		rcall	gps2_sel4
		cpi	tempreg1,0xed
		brne	gps2_manentry1
		ret

gps2_manentry1:	sts	bas_array+161,tempreg2	;which to modify
		ldi	ZL,LOW(gps2_ntext1*2)
		ldi	ZH,HIGH(gps2_ntext1*2)
		ldi	tempreg2,12
		libmio_nokey
		libmio_newtext	
		brtc	gps2_setent_e		;skip if esc
		ldi	ZL,LOW(libmio_tram)
		ldi	ZH,HIGH(libmio_tram)
		ldi	YL,LOW(1664)
		ldi	YH,HIGH(1664)
		lds	tempreg2,bas_array+161
		andi	tempreg2,0x03
		ldi	tempreg1,32
		mul	tempreg1,tempreg2
		add	YL,r0
		adc	YH,r1
		libmio_nokey
		ldi	XL,12
gps2_manent_01:	ld	tempreg1,Z+		
		libeep_write
		dec	XL
		brne	gps2_manent_01

		ldi	ZL,LOW(gps2_ntext2*2)
		ldi	ZH,HIGH(gps2_ntext2*2)
		ldi	tempreg2,11
		libmio_nokey
		libmio_newnum	
		brts	gps2_manent_03
		ldi	tempreg1,0x30
		ldi	XL,9
gps2_manent_02:	libeep_write
		dec	XL
		brne	gps2_manent_02
		ldi	tempreg1,'N'
		libeep_write
		rjmp	gps2_manent_10
		
gps2_manent_03:	ldi	tempreg2,9
		ldi	XL,'N'
		sts	bas_array+163,XL
		ldi	ZL,LOW(libmio_tram)
		ldi	ZH,HIGH(libmio_tram)		
gps2_manent_04:	ld	tempreg1,Z+		;first char
		cpi	tempreg1,'-'
		brne	gps2_manent_05
		ldi	XL,'S'
		sts	bas_array+163,XL		
		rjmp	gps2_manent_04
gps2_manent_05:	cpi	tempreg1,0x30		;number
		brcs	gps2_manent_04
		libeep_write
		dec	tempreg2
		brne	gps2_manent_04
		lds	tempreg1,bas_array+163
		libeep_write
		libmio_nokey

gps2_manent_10:	ldi	ZL,LOW(gps2_ntext3*2)
		ldi	ZH,HIGH(gps2_ntext3*2)
		ldi	tempreg2,11
		libmio_nokey
		libmio_newnum		
		brts	gps2_manent_13
		ldi	tempreg1,0x30
		ldi	XL,9
gps2_manent_12:	libeep_write
		dec	XL
		brne	gps2_manent_12
		ldi	tempreg1,'E'
		libeep_write
		rjmp	gps2_manent_20
		
gps2_manent_13:	ldi	tempreg2,9
		ldi	XL,'E'
		sts	bas_array+163,XL
		ldi	ZL,LOW(libmio_tram)
		ldi	ZH,HIGH(libmio_tram)		
gps2_manent_14:	ld	tempreg1,Z+		;first char
		cpi	tempreg1,'-'
		brne	gps2_manent_15
		ldi	XL,'W'
		sts	bas_array+163,XL		
		rjmp	gps2_manent_04
gps2_manent_15:	cpi	tempreg1,0x30		;number
		brcs	gps2_manent_14
		libeep_write
		dec	tempreg2
		brne	gps2_manent_14
		lds	tempreg1,bas_array+163
		libeep_write
		libmio_nokey					
		
gps2_manent_20:	ret				
		
						
;------------------------------------------------------------------------------
;entry menu
;------------------------------------------------------------------------------			
gps2_sel4:	libmio_menuheadf			;set menuhead
		libmio_menu4icons			;draw empty icons
		sts	libmio_font,const_1		;little font
		ldi	YL,LOW(1664)			;EE base
		ldi	YH,HIGH(1664)	
		ldi	tempreg4,0			;counter
		
gps2_sel4_03:	ldi	XL,8			;X-pos
		ldi	XH,12			;Y-pos
		sbrc	tempreg4,0
		subi	XL,0xc0			;X+64
		sbrc	tempreg4,1
		subi	XH,0xe4			;+28
		libmio_gotoxy				
		ldi	XL,12			;name len
gps2_sel4_04:	libeep_read			;get char
		sbrc	tempreg1,7
		ldi	tempreg1,0x20		;replace with space
		libmio_outchar
		dec	XL
		brne	gps2_sel4_04
		
		ldi	XL,8			;X-pos
		ldi	XH,20			;Y-pos
		sbrc	tempreg4,0
		subi	XL,0xc0			;X+64
		sbrc	tempreg4,1
		subi	XH,0xe4			;+28
		libmio_gotoxy				
		
		ldi	tempreg3,3
		rcall	gps2_sel4_o3
		ldi	tempreg1,','
		libmio_outchar

		ldi	tempreg3,7
		rcall	gps2_sel4_o3
		
		
		subi	XH,0xf8
		libmio_gotoxy	
		
		ldi	tempreg3,3
		rcall	gps2_sel4_o3
		ldi	tempreg1,','
		libmio_outchar

		ldi	tempreg3,7
		rcall	gps2_sel4_o3

		inc	tempreg4
		cpi	tempreg4,4
		brne	gps2_sel4_03
		
		
		libmio_nokey
		ldi	YL,LOW(2044)		;target selector (0-3)
		ldi	YH,HIGH(2044)
		libeep_read			;get value
		mov	tempreg2,tempreg1
		andi	tempreg2,0x03	
		
gps2_sel4_07:	libmio_imenu4			;start selection
		ret
	
	
gps2_sel4_o3:	libeep_read
		libmio_outchar
		dec	tempreg3
		brne	gps2_sel4_o3
		ret
				
;------------------------------------------------------------------------
; replace angle by XL data
;------------------------------------------------------------------------				
gps2_wxl:	ldi	XH,0x30			;"0"
gps2_wxl_1:	cpi	XL,10			
		brcs	gps2_wxl_2
		subi	XL,10
		inc	XH
		rjmp	gps2_wxl_1
gps2_wxl_2:	subi	XL,0xd0			;+"0"
		sts	bas_array+39,XH
		sts	bas_array+40,XL
		ret		
		

;------------------------------------------------------------------------
;do distance calculation
;bas_array+0		-> data from libgps
;bas_array+212		-> target lat in standard format
;bas_array+222		-> target long in standard format
;
;bas_array+154/155	-> distance (raw value)
;bas_array+153		-> factor
;f=0		a/10 m
;f=1		a m
;f=2		a/100 km
;f=3		a/10 km
;f=4		a km
;f=5		a*10km
;bas_array+156		-> target angle
;------------------------------------------------------------------------
gps2_ddc:	ldi	YL,LOW(bas_array+9)	;text of recent lat-1	
		ldi	YH,HIGH(bas_array+9)
		ldi	XL,LOW(bas_array+100)	;unpacked bcd B1
		ldi	XH,HIGH(bas_array+100)			
		rcall	gps2_bconvert		;convert data
		
		
		ldi	YL,LOW(bas_array+212)	;text of target lat	
		ldi	YH,HIGH(bas_array+212)
		ldi	XL,LOW(bas_array+108)	;unpacked bcd B2
		ldi	XH,HIGH(bas_array+108)			
		rcall	gps2_bconvert		;convert data		
		

		ldi	XL,LOW(bas_array+100)	;base
		ldi	XH,HIGH(bas_array+100)			
	
		lds	r16,bas_array+20 	;N/S recent
		lds	r17,bas_array+221	;N/S target
		cp	r16,r17
		breq	gps2_ddc_01		;we must calc diff
		sts	bas_array+148,r17	;target lat is direction 
		rcall	gps2_add		;add both values
		rjmp	gps2_ddc_10
	
gps2_ddc_01:	rcall	gps2_compare
		lds	r17,bas_array+221	;N/S target
		cpi	r19,0			;
		brne	gps2_ddc_04		;target is at higher value
		mov	r16,r17
		ldi	r17,'N'
		cpi	r16,'S'
		breq	gps2_ddc_04
		ldi	r17,'S'				
gps2_ddc_04:	sts	bas_array+148,r17	;target lat is direction 
		rcall	gps2_subtract						


gps2_ddc_10:	ldi	YL,LOW(bas_array+22)	;text of recent long	
		ldi	YH,HIGH(bas_array+22)
		ldi	XL,LOW(bas_array+124)	;unpacked bcd B1
		ldi	XH,HIGH(bas_array+124)			
		rcall	gps2_bconvert		;convert data
		
		ldi	YL,LOW(bas_array+222)	;text of target lat	
		ldi	YH,HIGH(bas_array+222)
		ldi	XL,LOW(bas_array+132)	;unpacked bcd B2
		ldi	XH,HIGH(bas_array+132)			
		rcall	gps2_bconvert		;convert data				


		ldi	XL,LOW(bas_array+124)	;base
		ldi	XH,HIGH(bas_array+124)			
						
		lds	r16,bas_array+33	;E/W recent
		lds	r17,bas_array+231	;E/W target
		cp	r16,r17
		breq	gps2_ddc_11		;we must calc diff
		sts	bas_array+149,r17	;target lat is direction 
		rcall	gps2_add		;add both values
		rjmp	gps2_ddc_20
	
gps2_ddc_11:	rcall	gps2_compare
		lds	r17,bas_array+231	;E/W target
		cpi	r19,0			;
		brne	gps2_ddc_14		;target is at higher value
		mov	r16,r17
		ldi	r17,'E'
		cpi	r16,'W'
		breq	gps2_ddc_14
		ldi	r17,'W'				
gps2_ddc_14:	sts	bas_array+149,r17	;target lat is direction 
		rcall	gps2_subtract								
		
gps2_ddc_20:	ldi	r19,0xff		;factor
gps2_ddc_21:	inc	r19			;factor +1		
		ldi	XL,LOW(bas_array+100)	;start of buffer
		ldi	XH,HIGH(bas_array+100)		
		rcall	gps2_check99		;shift right if > 99
		brts	gps2_ddc_21
		
		sts	bas_array+153,r19	;store factor
		
		clr	r20			;
		ldi	YL,LOW(bas_array+100)	;recent lat	
		ldi	YH,HIGH(bas_array+100)
		rcall	gps2_bcdbin1
		mov	r21,r20
		clr	r20			;
		ldi	YL,LOW(bas_array+108)	;target lat	
		ldi	YH,HIGH(bas_array+108)
		rcall	gps2_bcdbin1		
		add	r20,r21
		ror	r20			;
		ldi	ZL,LOW(gps2_costab*2)
		ldi	ZH,HIGH(gps2_costab*2)
		add	ZL,r20
		adc	ZH,const_0
		lpm	r16,Z
		sts	bas_array+152,r16	;factor
		
		ldi	YL,LOW(bas_array+122)	;lat diff	
		ldi	YH,HIGH(bas_array+122)		
		rcall	gps2_bcdbin2
		sts	bas_array+150,r20	;bin lat diff
		
		ldi	YL,LOW(bas_array+146)	;long diff	
		ldi	YH,HIGH(bas_array+146)		
		rcall	gps2_bcdbin2
		lds	r16,bas_array+152
		mul	r16,r20
		lsr	r20
		add	r0,r20
		adc	r1,const_0
		sts	bas_array+151,r1	;bin long diff
		
		mul	r1,r1			;long^2
		movw	XL,r0			;set
		
		lds	YL,bas_array+150	;lat diff
		mul	YL,YL
		add	XL,r0			;now we habe X^2 + Y^2
		adc	XH,r1		
;do square root
		mov	r16,XL			;copy value
		mov	r17,XH		
		ldi	XH,2			;offset for tempreg
		clr	XL			;clear result
		mov	r18,const_1		;set tempreg to 1
		clr	r19
gps2_ddc_30:	sub	r16,r18			;sub tempreg
		sbc	r17,r19
		brcs	gps2_ddc_31		;overflow
		inc	XL			;result+1
		add	r18,XH			;tempreg=tempreg+2
		adc	r19,const_0		;
		rjmp	gps2_ddc_30		;loop
gps2_ddc_31:	clr	XH			;		
		
		sts	bas_array+157,XL
		ldi	XH,111
		mul	XH,XL
		sts	bas_array+154,r0	;LOW distance
		sts	bas_array+155,r1	;HIGH distance
;now calc angle	
		ldi	r20,0			;target angle
		ldi	r21,0	
		lds	r16,bas_array+151	;dX
		lds	r17,bas_array+150	;dy
		lds	r18,bas_array+148	;Y flag
		lds	r19,bas_array+149	;X flag
		
;check for zero conditions
		mov	r20,r16
		or	r20,r17
		cpi	r20,0
		brne	gps2_ddc_41
gps2_ddc_40:	sts	bas_array+156,r20	;	
		ret
				
;shift to left		
gps2_ddc_41:	sbrc	r16,7
		rjmp	gps2_ddc_42
		sbrc	r17,7
		rjmp	gps2_ddc_42
		lsl	r16
		lsl	r17
		rjmp	gps2_ddc_41

gps2_ddc_42:	andi	r16,0xe0		;mask bits
		andi	r17,0xe0
		lsr	r16			;shift x
		lsr	r17			;shift y
		swap	r16
		or	r17,r16
		cpi	r18,'S'
		brne	gps2_ddc_43
		ori	r17,0x80
gps2_ddc_43:	cpi	r19,'W'
		brne	gps2_ddc_44
		ori	r17,0x08
gps2_ddc_44:	ldi	ZL,LOW(gps2_rtab*2)
		ldi	ZH,HIGH(gps2_rtab*2)
		add	ZL,r17
		adc	ZH,const_0
		lpm	r20,Z
		rjmp	gps2_ddc_40		
				
;------------------------------------------------------------------------
;convert lat degrees to bin
;------------------------------------------------------------------------		
gps2_bcdbin1:	ld	r16,Y+
		sbrc	r16,0
		ldi	r20,0x64		;+100
		ld	r16,Y+
		ldi	r17,10
		mul	r16,r17
		add	r20,r0			;+n*10
		ld	r16,Y+
		add	r20,r16			;+m*1
		ret
							
;------------------------------------------------------------------------
;convert degrees to bin
;------------------------------------------------------------------------		
gps2_bcdbin2:	ld	r16,Y+
		ldi	r17,10
		mul	r16,r17
		mov	r20,r0			;+n*10
		ld	r16,Y+
		add	r20,r16			;+m*1
		ret
									
;------------------------------------------------------------------------
;convert (Y) to (X) (recent)
;------------------------------------------------------------------------
gps2_bconvert:	ldi	r18,8			;pre-comma
gps2_bconv_1:	ld	r16,Y+
		cpi	r16,0x21		;space+1
		brcc	gps2_bconv_2
		ldi	r16,0x30
gps2_bconv_2:	subi	r16,0x30
		brcs	gps2_bconv_1
		st	X+,r16
		dec	r18
		brne	gps2_bconv_1
		ret	

;------------------------------------------------------------------------
;compare (X),(X+8) and exchange if V2>V1
;result in r19 
;0 no change (V1>=V2)
;1 changed (V2>V1)
;------------------------------------------------------------------------
gps2_compare:	movw	YL,XL			;pointer to v1
		clr	r19			;clear flag
		ldi	r18,8
gps2_compare_1:	ld	r16,Y+			;get v1
		ldd	r17,Y+7			;get v2
		cp	r16,r17
		brne	gps2_compare_3
		dec	r18
		brne	gps2_compare_1
gps2_compare_2:	ret
		
gps2_compare_3:	brcc	gps2_compare_2		;no change
		movw	YL,XL			;pointer to v1
		ldi	r18,8
gps2_compare_4:	ldd	r16,Y+8			;get v1
		ld	r17,Y						
		std	Y+8,r17
		st	Y+,r16
		dec	r18
		brne	gps2_compare_4
		ldi	r19,1			;set flag
		rjmp	gps2_compare_2		;end
		
;------------------------------------------------------------------------
;subtract (X)-(X+8)>(X+16)
;------------------------------------------------------------------------		
gps2_subtract:	movw	YL,XL			;pointer to v1
		ldi	r18,8			;number of digits
		adiw	YL,8			;beyond data
		clr	r20			;carry-flag
gps2_subtract_1:	ld	r16,-Y		;get v1
		ldd	r17,Y+8			;get v2
		sub	r16,r17			;sub
		sub	r16,r20			;sub carry
		clr	r20			;clear carry
		sbrs	r16,7			;skip if borrow
		rjmp	gps2_subtract_2		;
		ldi	r20,1			;set carry
		subi	r16,0xf6		;+10
gps2_subtract_2:	std	Y+16,r16	;store result
		dec	r18
		brne	gps2_subtract_1
		ret

;------------------------------------------------------------------------
;add (X)+(X+8)>(X+16)
;------------------------------------------------------------------------		
gps2_add:	movw	YL,XL			;pointer to v1
		ldi	r18,8			;number of digits
		adiw	YL,8			;beyond data
		clr	r20			;carry-flag
gps2_add_1:	ld	r16,-Y			;get v1
		ldd	r17,Y+8			;get v2
		add	r16,r17			;sub
		adc	r16,r20			;sub carry
		clr	r20			;clear carry
		cpi	r16,10
		brcs	gps2_add_2
		ldi	r20,1
		subi	r16,10
gps2_add_2:	std	Y+16,r16		;store result
		dec	r18
		brne	gps2_add_1
		ret	
		
;------------------------------------------------------------------------
;check if any value >99 (t is set)
;------------------------------------------------------------------------
gps2_check99:	movw	YL,XL
		ldi	r18,6			;numbers which must be zero
		clt				;clear > flag		
gps2_check99_1:	ldd	r16,Y+16		;result lat
		cpi	r16,0x00	
		breq	gps2_check99_2
		set				;set > flag
gps2_check99_2:	ldd	r16,Y+40		;result long
		cpi	r16,0x00	
		breq	gps2_check99_3
		set				;set > flag
gps2_check99_3:	adiw	YL,1
		dec	r18
		brne	gps2_check99_1
		brtc	gps2_check99_6
		
gps2_check99_4:	movw	YL,XL
		ldi	r18,7
gps2_check99_5:	ldd	r16,Y+22
		std	Y+23,r16
		ldd	r16,Y+46
		std	Y+47,r16		
		sbiw	YL,1
		dec	r18
		brne	gps2_check99_5
		std	Y+23,const_0
		std	Y+47,const_0
gps2_check99_6:	ret			


;------------------------------------------------------------------------
;round X value to 2 significant digits
;-----------------------------------------------------------------------		
gps2_round:	ldi	r16,LOW(10000)
		ldi	r17,HIGH(10000)
		cp	XL,r16
		cpc	XH,r17
		brcs	gps2_round_1		;is less than 10000
		
		ldi	r16,LOW(500)
		ldi	r17,HIGH(500)
		add	r16,XL
		adc	r17,XH
		ldi	XL,LOW(1000)
		ldi	XH,HIGH(1000)
		call	expar_udiv
		lsl	XL			;*1000
		lsl	XL
		ldi	XH,250
		mul	XL,XH
		movw	XL,r0
		ret
		
gps2_round_1:	ldi	r16,LOW(1000)
		ldi	r17,HIGH(1000)
		cp	XL,r16
		cpc	XH,r17
		brcs	gps2_round_2		;is less than 1000
		
		ldi	r16,LOW(50)
		ldi	r17,HIGH(50)
		add	r16,XL
		adc	r17,XH
		ldi	XL,LOW(100)
		ldi	XH,HIGH(100)
		call	expar_udiv
		ldi	XH,100			;*100
		mul	XL,XH
		movw	XL,r0
		ret		
		
gps2_round_2:	ldi	r16,LOW(100)
		ldi	r17,HIGH(100)
		cp	XL,r16
		cpc	XH,r17
		brcs	gps2_round_3		;is less than 100
		
		ldi	r16,LOW(50)
		ldi	r17,HIGH(50)
		add	r16,XL
		adc	r17,XH
		ldi	XL,LOW(10)
		ldi	XH,HIGH(10)
		call	expar_udiv
		ldi	XH,10			;*100
		mul	XL,XH
		movw	XL,r0
gps2_round_3:	ret		
					

