;################################################################################
;#										#
;# avr-chipbasic2m - mobile single chip basic computer with ATmega644		#
;# gps3 functions								#
;# copyright (c) 2008 Joerg Wolfram (joerg@jcwolfram.de)			#
;#										#
;#										#
;# This program is free software; you can redistribute it and/or		#
;# modify it under the terms of the GNU General Public License			#
;# as published by the Free Software Foundation; either version 2		#
;# of the License, or (at your option) any later version.			#
;#										#
;# This program is distributed in the hope that it will be useful,		#
;# but WITHOUT ANY WARRANTY; without even the implied warranty of		#
;# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.See the GNU		#
;# General Public License for more details.					#
;#										#
;# You should have received a copy of the GNU General Public			#
;# License along with this library; if not, write to the			#
;# Free Software Foundation, Inc., 59 Temple Place - Suite 330,			#
;# Boston, MA 02111-1307, USA.							#
;#										#
;################################################################################
;------------------------------------------------------------------------------
;main screen mask
;------------------------------------------------------------------------------
gps3_main:	ldi	ZL,LOW(libmio_icons*2+650)
		ldi	ZH,HIGH(libmio_icons*2+650)
		libmio_appframe
		libdfl_size
		cpi	tempreg1,0
		brne	gps3_main_02
		
		ldi	XL,34
		ldi	XH,27
		ldi	ZL,LOW(gps3_text_1*2)	;text pointer
		ldi	ZH,HIGH(gps3_text_1*2)
		libmio_xztext				
		rjmp	gps3_main_05

gps3_main_02:	ldi	XL,0
		ldi	XH,0
		ldi	YL,LOW(bas_array+512)
		ldi	YH,HIGH(bas_array+512)
		libdfl_readraw
		
		lds	tempreg1,bas_array+513
		cpi	tempreg1,'&'
		brne	gps3_main_04	
		lds	tempreg1,bas_array+514
		cpi	tempreg1,'G'
		breq	gps3_main_05
		
gps3_main_04:	ldi	XL,22
		ldi	XH,27
		ldi	ZL,LOW(gps3_text_2*2)	;text pointer
		ldi	ZH,HIGH(gps3_text_2*2)
		libmio_xztext				
		
gps3_main_05:	libmio_nokey

gps3_main_05a:	lds	XL,libmio_keycode
		cpi	XL,0xed			;ESC
		brne	gps3_main_06
		ret
		
gps3_main_06:	cpi	XL,0xe2			;left=menu
		brne	gps3_main_07
		rjmp	gps2_main
		
gps3_main_07:	cpi	XL,0xe3			;right=menu
		brne	gps3_main_05a
		rjmp	gps_main
		
		
gps3_main_10:	libmio_thistext		
		.db 0,10,"-GPS",0,0
		

gps3_main_20:  	ldi	YL,LOW(bas_array)
		ldi	YH,HIGH(bas_array)
		libgps_rrmc
		libmio_setinv
		sts	libmio_font,const_1	;small font
;output time		
		ldi	XL,40
		ldi	XH,2
		libmio_gotoxy						
		ldi	ZL,LOW(bas_array)
		ldi	ZH,HIGH(bas_array)
		libmio_ramtext
;output date		
		ldi	XL,80
		ldi	XH,2
		libmio_gotoxy						
		ldi	ZL,LOW(bas_array+43)
		ldi	ZH,HIGH(bas_array+43)
		libmio_ramtext

		lds	XL,libmio_keycode
		cpi	XL,0xed			;ESC
		brne	gps3_main_61
		ret

gps3_main_61:	cpi	XL,0xe5			;down=Zoom out
		brne	gps3_main_62
	
		rjmp	gps3_main
		
gps3_main_62:	cpi	XL,0xe2			;left=menu
		brne	gps3_main_63
		rjmp	gps2_main
		
gps3_main_63:	cpi	XL,0xe3			;right=menu
		brne	gps3_main_64
		rjmp	gps_main
		
gps3_main_64:	cpi	XL,0xe4			;up=Zoom in
		brne	gps3_main_20			

		rjmp	gps3_main
		
		
;------------------------------------------------------------------------
;convert actual data
;bas_array+0		-> data from libgps
;bas_array+200		-> lat in integer format
;bas_array+201		-> long in integer format
;------------------------------------------------------------------------
gps3_cad:	ldi	YL,LOW(bas_array+9)	;text of recent lat-1	
		ldi	YH,HIGH(bas_array+9)
		ldi	XL,LOW(bas_array+200)	;int
		ldi	XH,HIGH(bas_array+200)			
		lds	r16,bas_array+20 	;N/S recent
		clt
		cpi	r16,'N'
		breq	gps3_cad_1
		set
gps3_cad_1:	rcall	gps3_bconvert		;convert data to bin
	
		ldi	YL,LOW(bas_array+22)	;text of recent long	
		ldi	YH,HIGH(bas_array+22)
		ldi	XL,LOW(bas_array+202)	;unpacked bcd B1
		ldi	XH,HIGH(bas_array+202)
		lds	r16,bas_array+33	;E/W recent					
		clt
		cpi	r16,'E'
		breq	gps3_cad_2
		set
gps3_cad_2:	rcall	gps3_bconvert		;convert data
		ret
							
;------------------------------------------------------------------------
;convert 1/100 degrees to bin
;------------------------------------------------------------------------
gps3_bconvert:	ldi	ZL,0x00			;init to neutral
		ldi	ZH,0x80
		ld	r17,Y+			;deg*100
		cpi	r17,0x30
		brcc	gps3_bconv_1
		ldi	r17,0x30
		
gps3_bconv_1:	cpi	r17,0x30
		breq	gps3_bconv_3
		ldi	r18,LOW(10000)
		ldi	r19,HIGH(10000)
		brts	gps3_bconv_2
		add	ZL,r18
		adc	ZH,r19
		rjmp	gps3_bconv_1
gps3_bconv_2:	sub	ZL,r18
		sbc	ZH,r19
		rjmp	gps3_bconv_1
		
gps3_bconv_3:	ld	r17,Y+			;deg*10

gps3_bconv_4:	cpi	r17,0x30
		breq	gps3_bconv_6
		ldi	r18,LOW(1000)
		ldi	r19,HIGH(1000)
		brts	gps3_bconv_5
		add	ZL,r18
		adc	ZH,r19
		rjmp	gps3_bconv_4
gps3_bconv_5:	sub	ZL,r18
		sbc	ZH,r19
		rjmp	gps3_bconv_4
    		
	
gps3_bconv_6:	ld	r17,Y+			;deg*1
		subi	r17,0x30
		ldi	r18,100
		mul	r17,r18
		brts	gps3_bconv_7
		add	ZL,r0
		adc	ZH,r1
		rjmp	gps3_bconv_8
gps3_bconv_7:	sub	ZL,r0
		sbc	ZH,r1

gps3_bconv_8:	ld	r17,Y+			;sep
		ld	r17,Y+			;deg*1
		subi	r17,0x30
		ldi	r18,10
		mul	r17,r18
		brts	gps3_bconv_9
		add	ZL,r0
		adc	ZH,r1
		rjmp	gps3_bconv_10
gps3_bconv_9:	sub	ZL,r0
		sbc	ZH,r1
		
gps3_bconv_10:	ld	r17,Y+			;sep
		subi	r17,0x30
		brts	gps3_bconv_11
		add	ZL,r17
		adc	ZH,const_0
		rjmp	gps3_bconv_12
gps3_bconv_11:	sub	ZL,r17
		sbc	ZH,const_0
		
gps3_bconv_12:	ret


gps3_text_1:	.db "Kein Modul",0,0		
gps3_text_2:	.db "Keine Geodaten",0,0		
