;################################################################################
;#										#
;# avr-chipbasic2M - mobile single chip basic computer with ATmega644		#
;# counter functions								#
;# copyright (c) 2008 Joerg Wolfram (joerg@jcwolfram.de)			#
;#										#
;#										#
;# This program is free software; you can redistribute it and/or		#
;# modify it under the terms of the GNU General Public License			#
;# as published by the Free Software Foundation; either version 2		#
;# of the License, or (at your option) any later version.			#
;#										#
;# This program is distributed in the hope that it will be useful,		#
;# but WITHOUT ANY WARRANTY; without even the implied warranty of		#
;# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.See the GNU		#
;# General Public License for more details.					#
;#										#
;# You should have received a copy of the GNU General Public			#
;# License along with this library; if not, write to the			#
;# Free Software Foundation, Inc., 59 Temple Place - Suite 330,			#
;# Boston, MA 02111-1307, USA.							#
;#										#
;################################################################################

;------------------------------------------------------------------------------
;double counter
;------------------------------------------------------------------------------	
count_main:	ldi	ZL,LOW(libmio_icons*2+170)
		ldi	ZH,HIGH(libmio_icons*2+170)
		libmio_appframe
		ldi	XL,46
		ldi	XH,0
		ldi	ZL,LOW(count_text_1*2)	;text pointer
		ldi	ZH,HIGH(count_text_1*2)
		libmio_xztext						
		
		
count_main_2:	libmio_setnorm
		ldi	XL,16
		ldi	XH,18
		ldi	ZL,LOW(count_text_2*2)	;text pointer
		ldi	ZH,HIGH(count_text_2*2)
		libmio_xztext								
		libmio_thistext
		.db	255,"0",0,0
		
		ldi	XL,16
		ldi	XH,43
		ldi	ZL,LOW(count_text_2*2)	;text pointer
		ldi	ZH,HIGH(count_text_2*2)
		libmio_xztext								
		libmio_thistext
		.db	255,"1",0,0		
		
		ldi	YL,11
		ldi	YH,35
		ldi	ZL,116
		ldi	ZH,36
		libmio_box
		libmio_nokey
		in	tempreg6,PINA
		lds	tempreg5,libmio_keybits
;show counters		
count_main_3:	sts	libmio_font,const_0	;normal		
		ldi	XL,38
		ldi	XH,15		
		libmio_gotoxy	
		ldi	ctrl,0x4e
		lds	XL,count_ram
		lds	XH,count_ram+1
		libmio_outdez
		ldi	XL,38
		ldi	XH,40		
		libmio_gotoxy	
		ldi	ctrl,0x4e
		lds	XL,count_ram+2
		lds	XH,count_ram+3
		libmio_outdez

count_main_4:	lds	tempreg1,libmio_keybits
		in	tempreg2,PINA
		sbrc	tempreg1,4		;ESC
		rjmp	count_main_e
		sbrc	tempreg1,0		;left
		rjmp	count_main_s
		sbrc	tempreg1,1		;right
		rjmp	count_main_s
		mov	tempreg3,tempreg1
		mov	tempreg4,tempreg2
		
		eor	tempreg3,tempreg5
		and	tempreg3,tempreg1
		sbrc	tempreg3,2		;up
		rjmp	count_main_r
		sbrc	tempreg3,3		;down
		rcall	count_inc2
		sbrc	tempreg3,5		;ENT
		rcall	count_inc1
		eor	tempreg4,tempreg6
		and	tempreg4,tempreg6
		sbrc	tempreg4,0		;ch1
		rcall	count_inc1
		sbrc	tempreg4,1		;ch2
		rcall	count_inc2		

		
count_main_l:	mov	tempreg5,tempreg1
		mov	tempreg6,tempreg2
		libmio_sync
		rjmp	count_main_3			
		
count_main_e:	ret

count_main_r:	sts	count_ram,const_0
		sts	count_ram+1,const_0
		sts	count_ram+2,const_0
		sts	count_ram+3,const_0		
		rjmp	count_main_3
			
count_main_s:	rcall	count_stwas		
		rjmp	count_main	


count_inc1:	lds	XL,count_ram
		add	XL,const_1
		sts	count_ram,XL
		lds	XL,count_ram+1
		adc	XL,const_0
		sts	count_ram+1,XL
		ret

count_inc2:	lds	XL,count_ram+2
		add	XL,const_1
		sts	count_ram+2,XL
		lds	XL,count_ram+3
		adc	XL,const_0
		sts	count_ram+3,XL
		ret
		
;------------------------------------------------------------------------------
;store counter (EEPROM base address is 1856)
;------------------------------------------------------------------------------		
count_stwas:	ldi	ZL,LOW(count_swstext1*2)	;text
		ldi	ZH,HIGH(count_swstext1*2)
		lds	XL,libmio_rtc
		andi	XL,0xfd
		sts	libmio_rtc,XL

count_stwas_01:	libmio_menuheadf			;set menuhead
		libmio_menu4icons			;draw empty icons
		sts	libmio_font,const_1		;little font
		ldi	YL,LOW(1856)			;EE base
		ldi	YH,HIGH(1856)	
		ldi	tempreg4,0			;counter
		
count_stwas_03:	ldi	XL,8			;X-pos
		ldi	XH,12			;Y-pos
		sbrc	tempreg4,0
		subi	XL,0xc0			;X+64
		sbrc	tempreg4,1
		subi	XH,0xe4			;+28
		libmio_gotoxy				
		ldi	XL,12			;name len
count_stwas_04:	libeep_read			;get char
		sbrc	tempreg1,7
		ldi	tempreg1,0x20		;replace with space
		libmio_outchar
		dec	XL
		brne	count_stwas_04
		ldi	XL,14			;X-pos
		ldi	XH,20			;Y-pos
		sbrc	tempreg4,0
		subi	XL,0xc0			;X+64
		sbrc	tempreg4,1
		subi	XH,0xe4			;+28
		push	XL
		push	XH
		libmio_gotoxy
		lds	tempreg1,count_text_2
		libmio_outchar		
		libmio_thistext
		.db	255,"0: ",0,0						
		ldi	ctrl,0x0e		;write LAP time
		libeep_read
		mov	XL,tempreg1
		libeep_read
		mov	XH,tempreg1		
		libmio_outdez
		pop	XH
		pop	XL
		subi	XH,0xf8
		libmio_gotoxy
		lds	tempreg1,count_text_2
		libmio_outchar
		libmio_thistext
		.db	255,"1: ",0,0						
		ldi	ctrl,0x0e
		libeep_read
		mov	XL,tempreg1
		libeep_read
		mov	XH,tempreg1			
		libmio_outdez

		inc	tempreg4
		cpi	tempreg4,4
		brne	count_stwas_3x
		libmio_nokey
		clr	tempreg2
		
count_stwas_05:	libmio_imenu4			;start selection
		cpi	tempreg1,0xed		;esc
		brne	count_stwas_06
		sts	libmio_font,const_0	;big font		
		ret				;back to stopp-watch
			
count_stwas_3x:	rjmp	count_stwas_03		;jump extender		
		
count_stwas_06:	ldi	YL,LOW(1856+12)		;EE base+skip name
		ldi	YH,HIGH(1856+12)			
		sbrc	tempreg2,0
		adiw	YL,16
		sbrc	tempreg2,1
		adiw	YL,32	
		
		ldi	ZL,LOW(count_sstext*2)
		ldi	ZH,HIGH(count_sstext*2)
		ldi	tempreg2,12
		libmio_newtext	
		brtc	count_stwas_08		;skip if esc
		sbiw	YL,12			;reset pointer to start of name			
		ldi	ZL,LOW(libmio_tram)
		ldi	ZH,HIGH(libmio_tram)		
		ldi	XL,12
count_stwas_07:	ld	tempreg1,Z+
		libeep_write
		dec	XL
		brne	count_stwas_07
;now write counters		
count_stwas_08:	lds	tempreg1,count_ram	;
		libeep_write
		lds	tempreg1,count_ram+1	;
		libeep_write
		lds	tempreg1,count_ram+2	;
		libeep_write
		lds	tempreg1,count_ram+3	;
		libeep_write				
		rjmp	count_stwas		;loop		
		
