;################################################################################
;#										#
;# avr-chipbasic2M - mobile single chip basic computer with ATmega644		#
;# mini logic analyzer								#
;# copyright (c) 2008 Joerg Wolfram (joerg@jcwolfram.de)			#
;#										#
;#										#
;# This program is free software; you can redistribute it and/or		#
;# modify it under the terms of the GNU General Public License			#
;# as published by the Free Software Foundation; either version 2		#
;# of the License, or (at your option) any later version.			#
;#										#
;# This program is distributed in the hope that it will be useful,		#
;# but WITHOUT ANY WARRANTY; without even the implied warranty of		#
;# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.See the GNU		#
;# General Public License for more details.					#
;#										#
;# You should have received a copy of the GNU General Public			#
;# License along with this library; if not, write to the			#
;# Free Software Foundation, Inc., 59 Temple Place - Suite 330,			#
;# Boston, MA 02111-1307, USA.							#
;#										#
;################################################################################

;------------------------------------------------------------------------------
;main menu
;------------------------------------------------------------------------------		
minla_main:	ldi	tempreg1,0x01		;c for la
		sts	rdata_head+25,tempreg1	;type byte
		ldi	YL,LOW(2033)
		ldi	YH,HIGH(2033)
		libeep_read
minla_geep_1:	cpi	tempreg1,14
		brcs	minla_geep_2
		ldi	tempreg1,13
minla_geep_2:	sts	rdata_head+23,tempreg1		;sr
			
		ldi	YL,LOW(2034)
		ldi	YH,HIGH(2034)
		libeep_read
minla_geep_3:	sts	rdata_head+24,tempreg1		;mode
		
		ldi	ZL,LOW(2000)		;1 num of bytes
		ldi	ZH,HIGH(2000)		;1			
		ldi	YL,LOW(rdata_buf)	;set buffer start
		ldi	YH,HIGH(rdata_buf)	
minla_sample0:	st	Y+,const_0		;fill buffer with zeros
		sbiw	ZL,1
		brne	minla_sample0				
			
minla_main_0:	clr	tempreg2		
minla_main_re:	ldi	ZL,LOW(minla_dmain*2)
		ldi	ZH,HIGH(minla_dmain*2)
		libmio_copymenu
		rcall	minla_dconf
minla_main_1:	set
		ldi	r19,5
		libmio_menu5
		cpi	tempreg1,0xed
		brne	minla_main_11
		ret
minla_main_11:	
		cpi	tempreg2,1
		brne	minla_main_2
		rcall	minla_dsr
		ldi	tempreg2,1
		rjmp	minla_main_re

minla_main_2:	cpi	tempreg2,2
		brne	minla_main_3
		rcall	minla_dtm
		ldi	tempreg2,2		
		rjmp	minla_main_re
		
minla_main_3:	cpi	tempreg1,0xea
		brne	minla_main_1
		cpi	tempreg2,0
		brne	minla_main_4
		
		libmio_oborder
		ldi	XL,19
		ldi	XH,27
		ldi	ZL,LOW(mincu_text_1*2)	;text pointer
		ldi	ZH,HIGH(mincu_text_1*2)
		libmio_xztext					

		libmio_sync
		libmio_sync
		rcall	minla_sample
		rcall	minla_view		
		ldi	tempreg2,0
		rjmp	minla_main_re
		
minla_main_4:	cpi	tempreg2,3
		brne	minla_main_5
		rcall	minla_view		
		ldi	tempreg2,3
		rjmp	minla_main_re
	
minla_main_5:	rcall	minla_fmenu
		ldi	tempreg2,4
	    	rjmp	minla_main_re		
		ret		

;------------------------------------------------------------------------------
;file menu
;------------------------------------------------------------------------------	
minla_fmenu:	clr	tempreg2		
minla_fmenu_re:	ldi	ZL,LOW(minla_dfile*2)
		ldi	ZH,HIGH(minla_dfile*2)
		libmio_copymenu
minla_fmenu_1:	set
		ldi	r19,4
		libmio_menu5
		cpi	tempreg1,0xed
		brne	minla_fmenu_2
		ret
minla_fmenu_2:	cpi	tempreg1,0xea
		brne	minla_fmenu_1
		
		cpi	tempreg2,0
		brne	minla_fmenu_3
		call	fsys_savemd
		ldi	tempreg2,0
		rjmp	minla_fmenu_re

minla_fmenu_3:	cpi	tempreg2,1
		brne	minla_fmenu_4
		call	fsys_loadmd
		ldi	tempreg2,1		
		rjmp	minla_fmenu_re
		
minla_fmenu_4:	cpi	tempreg2,2
		brne	minla_fmenu_5
		call	send_ram
		ldi	tempreg2,2		
		rjmp	minla_fmenu_re

minla_fmenu_5:	cpi	tempreg2,3
		brne	minla_fmenu_1
		call	recv_ram
		ldi	tempreg2,3		
		rjmp	minla_fmenu_re
		
;------------------------------------------------------------------------------
;dec/inc sample rate index
;------------------------------------------------------------------------------	
minla_dsr:	cpi	tempreg1,0xe2		;left
		brne	minla_dsr_10
		lds	tempreg1,rdata_head+23	;sr
		inc	tempreg1
		cpi	tempreg1,14
		brcs	minla_dsr_1
		ldi	tempreg1,0
minla_dsr_1:	sts	rdata_head+23,tempreg1
		ldi	YL,LOW(2033)
		ldi	YH,HIGH(2033)
		libeep_write
		ret
		
minla_dsr_10:	lds	tempreg1,rdata_head+23	;sr
		subi	tempreg1,1
		brcc	minla_dsr_1
		ldi	tempreg1,13
		rjmp	minla_dsr_1
		

;------------------------------------------------------------------------------
;dec/inc trigger mode
;------------------------------------------------------------------------------	
minla_dtm:	cpi	tempreg1,0xe2		;left
		brne	minla_dtm_10

		lds	tempreg1,rdata_head+24	;trig
		lsr	tempreg1
		cpi	tempreg1,0x00
		brne	minla_dtm_1
		ldi	tempreg1,0x10
minla_dtm_1:	sts	rdata_head+24,tempreg1
		ldi	YL,LOW(2034)
		ldi	YH,HIGH(2034)
		libeep_write
		ret
	
minla_dtm_10:	lds	tempreg1,rdata_head+24	;trig
		lsl	tempreg1
		cpi	tempreg1,0x20
		brcs	minla_dtm_1
		ldi	tempreg1,1
		rjmp	minla_dtm_1

;------------------------------------------------------------------------------
;copy conf data into menu
;------------------------------------------------------------------------------	
minla_dconf:	ldi	ZL,LOW(minla_cdata_s*2)
		ldi	ZH,HIGH(minla_cdata_s*2)
		ldi	XL,6			;bytes per entry
		lds	tempreg1,rdata_head+23	;sr
		mul	XL,tempreg1		;* srate
		add	ZL,r0
		adc	ZH,r1
		ldi	YL,LOW(libmio_mram+50)
		ldi	YH,HIGH(libmio_mram+50)
		ldi	XL,6
minla_dconf_1:	lpm	XH,Z+
		st	Y+,XH
		dec	XL
		brne	minla_dconf_1
	
		ldi	ZL,LOW(minla_cdata_m*2)
		ldi	ZH,HIGH(minla_cdata_m*2)		
		ldi	XL,5
		lds	XH,rdata_head+24
minla_dconf_2:	lsr	XH
		brcs	minla_dconf_3
		adiw	ZL,6
		dec	XL
		brne	minla_dconf_2
		ret
		
minla_dconf_3:	ldi	XL,6
		ldi	YL,LOW(libmio_mram+68)
		ldi	YH,HIGH(libmio_mram+68)
minla_dconf_4:	lpm	XH,Z+
		st	Y+,XH
		dec	XL
		brne	minla_dconf_4
		ret
		
		
;------------------------------------------------------------------------------
;do sampling
;tempreg3	tr1/tr2		fsample		tmess
;	0	 d.c.		    4M		1.77 ms
;	1	    1		    1M		7.10 ms
;	2	    5		  500k	       14.20 ms
;	3	   17		  200k	       35.52 ms
;	4	   37		  100k	       71.04 ms
;	5	   77		   50k	      142.08 ms
;	6	  197		   20k	      355.20 ms
;	7	  397		   10k	      710.40 ms
;	8	  797		    5k	        1.42 s
;	9	 1997		    2k	        3.55 s
;      10	 3997		    1k	 	7.10 s
;      11	 7997		   500	       14.20 s
;      12	19997		   200	       35.52 s
;      13	39997		   100	       71.04 s
;
;	bit 0	E0 rising
;	bit 1	E0 falling
;   	bit 2	E1 rising
;	bit 3	E1 falling
;	bit 4	immediate
;
;------------------------------------------------------------------------------
minla_sample:	cli				;disable interrupts			
		ldi	YL,LOW(rdata_buf)	;set buffer start
		ldi	YH,HIGH(rdata_buf)	
		ldi	ZL,LOW(minla_srd*2)	;sample rate data
		ldi	ZH,HIGH(minla_srd*2)	;sample rate data			
		lds	tempreg1,rdata_head+23
		cpi	tempreg1,0
		breq	minla_sample1		;4MHZ
		dec	tempreg1
		lsl	tempreg1
		add	ZL,tempreg1
		adc	ZH,const_0
		lpm	tempreg1,Z+		;get low byte
		lpm	tempreg2,Z+		;get high byte
		ldi	ZL,LOW(2000/2)		;1 num of words
		ldi	ZH,HIGH(2000/2)		;1			
		lds	r16,UCSR0B
		andi	r16,0xf7		;clear TXEN bit
		sts	UCSR0B,r16							
		sbi	PORTD,1			;2 set trig LED off						
		lds	tempreg4,rdata_head+24						
		sbrc	tempreg4,0		;E0 rising
		rcall	minla_t1h0
		sbrc	tempreg4,1		;E0 falling
		rcall	minla_t1l0				
		sbrc	tempreg4,2		;E1 rising
		rcall	minla_t1h1
		sbrc	tempreg4,3		;E1 falling
		rcall	minla_t1l1							
		sbrc	tempreg4,4		;immediate
		rcall	minla_t1i												
		lds	r16,UCSR0B
		ori	r16,0x08		;set TXEN bit
		sts	UCSR0B,r16
		sei				;re-enable interrupts											
		ret
;4MHz mode
minla_sample1:	ldi	ZL,LOW(2000/2)		;1 num of words
		ldi	ZH,HIGH(2000/2)		;1			
		lds	r16,UCSR0B
		andi	r16,0xf7		;clear TXEN bit
		sts	UCSR0B,r16							
		sbi	PORTD,1			;2 set trig LED off
		lds	tempreg4,rdata_head+24						
		sbrc	tempreg4,0		;E0 rising
		rcall	minla_t4h0
		sbrc	tempreg4,1		;E0 falling
		rcall	minla_t4l0				
		sbrc	tempreg4,2		;E1 rising
		rcall	minla_t4h1
		sbrc	tempreg4,3		;E1 falling
		rcall	minla_t4l1	
		sbrc	tempreg4,4		;immediate
		rcall	minla_t4i																					
		lds	r16,UCSR0B
		ori	r16,0x08		;set TXEN bit
		sts	UCSR0B,r16	
		sei				;re-enable interrupts																	
		ret			

;------------------------------------------------------------------------------
;4 MHZ sample rate
;------------------------------------------------------------------------------
;trigger to high E0
minla_t4h0:	sbic	PINA,0			;wait for inactive
		rjmp	minla_t4h0
minla_t4h0a:	in	r18,PINA		;1 get data
		sbrc	r18,0			;1 skip if no active
		rjmp	minla_read4		;2 read data
		sbic	PIND,3
		rjmp	minla_t4h0a		;2
		clt				;esc flag
		ret				;end

;trigger to low E0								
minla_t4l0:	sbis	PINA,0			;wait for inactive
		rjmp	minla_t4l0
minla_t4l0a:	in	r18,PINA		;1 get data
		sbrs	r18,0			;1 skip if no active
		rjmp	minla_read4		;2 read data
		sbic	PIND,3			;1 ESC
		rjmp	minla_t4l0a		;2
		clt				;esc flag
		ret				;end				
				
;trigger to high E1
minla_t4h1:	sbic	PINA,1			;wait for inactive
		rjmp	minla_t4h1
minla_t4h1a:	in	r18,PINA		;1 get data
		sbrc	r18,1			;1 skip if no active
		rjmp	minla_read4		;2 read data
		sbic	PIND,3			;1 ESC
		rjmp	minla_t4h1a		;2
		clt				;esc flag
		ret				;end

;trigger to low E1								
minla_t4l1:	sbis	PINA,0			;wait for inactive
		rjmp	minla_t4l1
minla_t4l1a:	in	r18,PINA		;1 get data
		sbrs	r18,1			;1 skip if no active
		rjmp	minla_read4		;2 read data
		sbic	PIND,3			;1 ESC
		rjmp	minla_t4l1a		;2
		clt				;esc flag
		ret				;end

;immediate								
minla_t4i:	in	r18,PINA		;1 get data
		nop				;1
		rjmp	minla_read4		;2
																
;now sample data							
minla_read4:	out	PORTD,const_0		;1 LED on

minla_read4_1:	in	r16,PINA		;1	
		st	Y+,r18			;2
		st	Y+,r16			;2
		
		in	r18,PINA	
		sbiw	ZL,1			;2
		brne	minla_read4_1		;2
		set				;done flag
		ret				;end
						
;------------------------------------------------------------------------------
;small sample rates
;------------------------------------------------------------------------------			
;trigger to high E0
minla_t1h0:	sbic	PINA,0			;wait for inactive
		rjmp	minla_t1h0
minla_t1h0a:	in	r18,PINA		;1 get data
		sbrc	r18,0			;1 skip if no active
		rjmp	minla_read1		;2 read data
		sbic	PIND,3			;1 ESC
		rjmp	minla_t1h0a		;2
		clt				;esc flag
		ret				;end

;trigger to low E0								
minla_t1l0:	sbis	PINA,0			;wait for inactive
		rjmp	minla_t1l0
minla_t1l0a:	in	r18,PINA		;1 get data
		sbrs	r18,0			;1 skip if no active
		rjmp	minla_read1		;2 read data
		sbic	PIND,3			;1 ESC
		rjmp	minla_t1l0a		;2
		clt				;esc flag
		ret				;end				
				
;trigger to high E1
minla_t1h1:	sbic	PINA,1			;wait for inactive
		rjmp	minla_t1h1
minla_t1h1a:	in	r18,PINA		;1 get data
		sbrc	r18,1			;1 skip if no active
		rjmp	minla_read1		;2 read data
		sbic	PIND,3			;1 ESC
		rjmp	minla_t1h1a		;2
		clt				;esc flag
		ret				;end

;trigger to low E1								
minla_t1l1:	sbis	PINA,0			;wait for inactive
		rjmp	minla_t1l1
minla_t1l1a:	in	r18,PINA		;1 get data
		sbrs	r18,1			;1 skip if no active
		rjmp	minla_read1		;2 read data
		sbic	PIND,3			;1 ESC
		rjmp	minla_t1l1a		;2
		clt				;esc flag
		ret				;end								
;immediate				
minla_t1i:	in	r18,PINA		;1 get data
		nop				;1
		rjmp	minla_read1		;2				


;now sample data							
minla_read1:	out	PORTD,const_0		;1 LED on

minla_read1_1:	rcall	minla_sdel		;n sample del
		in	r16,PINA		;1	
		st	Y+,r18			;2
		st	Y+,r16			;2

		rcall	minla_sdel		;n sample del
		in	r18,PINA	
		sbiw	ZL,1			;2
		brne	minla_read1_1		;2
		set				;done flag
		ret				;end

			
minla_sdel:	mov	XL,tempreg1		;2
		mov	XH,tempreg2
minla_sdel_1:	sbiw	XL,1			;2
		nop				;1
		brne	minla_sdel_1		;1/2
		ret				;5		



;------------------------------------------------------------------------------
;view results
;------------------------------------------------------------------------------			
minla_view:	ldi	YL,LOW(rdata_ram)
		ldi	YH,HIGH(rdata_ram)
		ldi	XL,7
minla_view_0:	st	Y+,const_0
		dec	XL
		brne	minla_view_0		
		sts	rdata_ram+9,const_0
		sts	rdata_ram+10,const_0
				
		ldi	ZL,LOW(libmio_icons*2+10)
		ldi	ZH,HIGH(libmio_icons*2+10)
		libmio_appframe			;draw appframe
		
		sts	libmio_font,const_1
		libmio_thistext
		.db	2,16,"Mini-LA",0		
		ldi	XL,1
		libmio_setcolor			;set to normal


		ldi	YL,9
		ldi	YH,41
		ldi	ZL,118
		ldi	ZH,42		
		libmio_fbox			;separator 1
		
		ldi	YL,9
		ldi	YH,10
		ldi	ZL,15
		ldi	ZH,40		
		libmio_fbox			;box for channel numbers
					
		ldi	XL,0			;inverse
		libmio_setcolor
		libmio_thistext
		.db	17,12,"1",0
		libmio_thistext
		.db	29,12,"0",0
		sts	libmio_font,const_0

		
		libmio_thistext
		.db	43,10,"TC:",0
		libmio_thistext
		.db	43,64,"dT:",0		
		libmio_thistext
		.db	53,10,"TM:",0
		libmio_thistext
		.db	53,64,"Fr:",0
		ldi	XL,1			;normal
		libmio_setcolor

minla_view_l:	libmio_nokey	
minla_view_1:	rcall	minla_show
minla_view_re:	rcall	minla_wp		;show window pos
		rcall	minla_scur1		;show cursor		
		rcall	minla_sval

minla_view_2:	call	libmio_nokeys
		call	libmio_waitkey
		cpi	tempreg1,0xed		;end
		brne	minla_view_3		
		ret		

minla_view_3:	cpi	tempreg1,0xe2		;left
		brne	minla_view_4
		rcall	minla_scur0		;hide cursor			
		clr	tempreg1
		rcall	minla_movc
		brtc	minla_view_re
		rjmp	minla_view_1


minla_view_4:	cpi	tempreg1,0xe3		;right
		brne	minla_view_5
		rcall	minla_scur0		;hide cursor			
		ldi	tempreg1,1
		rcall	minla_movc
		brtc	minla_view_re
		rjmp	minla_view_1
				
minla_view_5:	cpi	tempreg1,0xe4		;up
		brne	minla_view_6		
		ldi	tempreg1,2		;window -
		rcall	minla_movc
		rjmp	minla_view_1


minla_view_6:	cpi	tempreg1,0xe5		;down
		brne	minla_view_7
		ldi	tempreg1,3		;window +
		rcall	minla_movc
		rjmp	minla_view_1

minla_view_7:	cpi	tempreg1,0xea		;enter
		brne	minla_view_2
		lds	YL,rdata_ram+2		;cursor pos
		lds	YH,rdata_ram+3		
		sts	rdata_ram+9,YL
		sts	rdata_ram+10,YH
		rjmp	minla_view_1
		

;------------------------------------------------------------------------------
;follow cusor
;------------------------------------------------------------------------------			
minla_movc:	lds	XL,rdata_ram+0		;window pos
		lds	XH,rdata_ram+1
		lds	YL,rdata_ram+2		;cursor pos
		lds	YH,rdata_ram+3		
		clt				;no change window pos
		sbrc	tempreg1,1		;skip if move_dist=1
		rjmp	minla_movc_1
;move cursor +-1
		sbrc	tempreg1,0				
		adiw	YL,1
		sbrs	tempreg1,0
		sbiw	YL,1
		rjmp	minla_movc_2
;move cursor +-25
minla_movc_1:	sbrc	tempreg1,0		
		adiw	YL,25			;move cursor right
		sbrs	tempreg1,0
		sbiw	YL,25			;move cursor left
		sbrc	tempreg1,0		
		adiw	XL,25			;move window right
		sbrs	tempreg1,0
		sbiw	XL,25			;move window left
		set				;set change flag
				
;check for borders, limit cursor								
minla_movc_2:	cpi	YH,0x80			;overflow
		brcs	minla_movc_2a
		clr	YL
		clr	YH
minla_movc_2a:	ldi	ZL,LOW(2000)
		ldi	ZH,HIGH(2000)
		cp	YL,ZL
		cpc	YH,ZH			;carry is set if <1750
		brcs	minla_movc_3		
		ldi	YL,LOW(1999)
		ldi	YH,HIGH(1999)
minla_movc_3:	sts	rdata_ram+2,YL		;store new cursor position
		sts	rdata_ram+3,YH
		

;check if we must move window		
		movw	ZL,YL			;copy cursor pos
		sub	ZL,XL			;subtract window pos
		sbc	ZH,XH
		brcc	minla_movc_4		;branch if win<=cursor	
		movw	XL,YL			;window pos=cursor pos
		set				;set change flag
		rjmp	minla_movc_5
		
minla_movc_4:	cpi	ZL,50
		brcs	minla_movc_5
		movw	XL,YL			;window pos=cursor pos
		sbiw	XL,49			;-49
		set				;set change flag			

;check for borders, limit window								
minla_movc_5:	cpi	XH,0x80			;overflow
		brcs	minla_movc_5a
		clr	XL
		clr	XH
minla_movc_5a:	ldi	ZL,LOW(1950)
		ldi	ZH,HIGH(1950)
		cp	XL,ZL
		cpc	XH,ZH			;carry is set if <1750
		brcs	minla_movc_6
		ldi	XL,LOW(1950)
		ldi	XH,HIGH(1950)
minla_movc_6:	sts	rdata_ram+0,XL		;store new window position
		sts	rdata_ram+1,XH
		lds	YL,rdata_ram+2		;cursor pos
		sub	YL,XL
		sts	rdata_ram+6,YL		;set new cursor offset						
		ret	

;------------------------------------------------------------------------------
;show winpos
;------------------------------------------------------------------------------			
minla_wp:	ldi	XL,0			;invers
		libmio_setcolor
		ldi	YL,50
		ldi	YH,2
		ldi	ZL,116
		ldi	ZH,5		
		libmio_fbox			
		ldi	XL,1			;normal
		libmio_setcolor
		lds	XL,rdata_ram+0
		lds	XH,rdata_ram+1
		ldi	YL,5
minla_wp_1:	lsr	XH
		ror	XL
		dec	YL
		brne	minla_wp_1
		ldi	YL,51
		add	YL,XL
		mov	ZL,YL
		inc	ZL
		ldi	YH,3
		ldi	ZH,4
		libmio_fbox
		ret

;------------------------------------------------------------------------------
;view values
;------------------------------------------------------------------------------			
minla_sval:	sts	libmio_font,const_1
		ldi	XL,30			;TC
		ldi	XH,45
		libmio_gotoxy
		lds	XL,rdata_ram+2		;cursor pos
		lds	XH,rdata_ram+3		
		rcall	minla_cval
		libmio_outdez
		mov	tempreg1,tempreg3
		libmio_outchar
		
		ldi	XL,30
		ldi	XH,55
		libmio_gotoxy
		lds	XL,rdata_ram+9		;mark pos
		lds	XH,rdata_ram+10		
		rcall	minla_cval
		libmio_outdez
		mov	tempreg1,tempreg3
		libmio_outchar

		ldi	XL,84
		ldi	XH,45
		libmio_gotoxy
		lds	XL,rdata_ram+2		;cursor pos
		lds	XH,rdata_ram+3		
		lds	YL,rdata_ram+9		;mark pos
		lds	YH,rdata_ram+10		
		sub	XL,YL
		sbc	XH,YH
		call	expar_absa
		call	minla_cval
		libmio_outdez
		mov	tempreg1,tempreg3
		libmio_outchar

		ldi	XL,84
		ldi	XH,55
		libmio_gotoxy
		lds	XL,rdata_ram+2		;cursor pos
		lds	XH,rdata_ram+3		
		lds	YL,rdata_ram+9		;mark pos
		lds	YH,rdata_ram+10		
		sub	XL,YL
		sbc	XH,YH
		call	expar_absa
		cpi	XH,0
		brne	minla_sval1
		cpi	XL,0
		brne	minla_sval1
		libmio_thistext
		.db	255,"-----   ",0
		ret
		
minla_sval1:	call	minla_cfreq
		libmio_outdez
		mov	tempreg1,tempreg3
		libmio_outchar
		ret

;------------------------------------------------------------------------------
;calc t from X
;------------------------------------------------------------------------------			
minla_cval:	lds	tempreg4,rdata_head+23	;sr
		ldi	r17,0			;factor H is always zero
		ldi	tempreg3,0x1e		;micro
		ldi	ctrl,0x2e		;3+2
		cpi	tempreg4,0		;4M
		brne	minla_cval_01
		ldi	r16,25
		rjmp	minla_cval_20

minla_cval_01:	ldi	ctrl,0x0e		;5+0
		cpi	tempreg4,1		;1M
		brne	minla_cval_02
		ldi	r16,1			
		rjmp	minla_cval_20

minla_cval_02:	cpi	tempreg4,2		;500k
		brne	minla_cval_03
		ldi	r16,2			
		rjmp	minla_cval_20

minla_cval_03:	cpi	tempreg4,3		;200k
		brne	minla_cval_04
		ldi	r16,5			
		rjmp	minla_cval_20
		
minla_cval_04:	cpi	tempreg4,4		;100k
		brne	minla_cval_05
		ldi	r16,10			
		rjmp	minla_cval_20
		
minla_cval_05:	cpi	tempreg4,5		;50k
		brne	minla_cval_06
		ldi	r16,20			
		rjmp	minla_cval_20

minla_cval_06:	ldi	ctrl,0x2e		;3+2
		ldi	tempreg3,'M'		;milli
		cpi	tempreg4,6		;20k
		brne	minla_cval_07
		ldi	r16,5			
		rjmp	minla_cval_20

minla_cval_07:	ldi	ctrl,0x1e		;4+1
		cpi	tempreg4,7		;10k
		brne	minla_cval_08
		ldi	r16,1			
		rjmp	minla_cval_20

minla_cval_08:	cpi	tempreg4,8		;5k
		brne	minla_cval_09
		ldi	r16,2			
		rjmp	minla_cval_20

minla_cval_09:	cpi	tempreg4,9		;2k
		brne	minla_cval_10
		ldi	r16,5			
		rjmp	minla_cval_20

minla_cval_10:	ldi	ctrl,0x0e		;5+0
		cpi	tempreg4,10		;1k
		brne	minla_cval_11
		ldi	r16,1			
		rjmp	minla_cval_20

minla_cval_11:	cpi	tempreg4,11		;500
		brne	minla_cval_12
		ldi	r16,2			
		rjmp	minla_cval_20

minla_cval_12:	cpi	tempreg4,12		;200
		brne	minla_cval_13
		ldi	r16,5			
		rjmp	minla_cval_20

minla_cval_13:	ldi	ctrl,0x2e		;3+2
		ldi	tempreg3,0x20		;none (secs)
		ldi	r16,10			;100			

		
minla_cval_20:	call	mul16b			;mult
		movw	XL,r18
		ret

;------------------------------------------------------------------------------
;calc f from X
;------------------------------------------------------------------------------			
minla_cfreq:	
		
minla_cfreq_00:	lds	tempreg4,rdata_head+23	;sr
		ldi	tempreg3,'K'		;micro
		ldi	ctrl,0x1e		;4+1
		cpi	tempreg4,0		;4M
		brne	minla_cfreq_01
		ldi	r16,LOW(40000)
		ldi	r17,HIGH(40000)		;	
		rjmp	minla_cfreq_20

minla_cfreq_01:	cpi	tempreg4,1		;1M
		brne	minla_cfreq_02
		ldi	r16,LOW(10000)
		ldi	r17,HIGH(10000)		;		
		rjmp	minla_cfreq_20

minla_cfreq_02:	ldi	ctrl,0x2e		;3+2
		cpi	tempreg4,2		;500k
		brne	minla_cfreq_03
		ldi	r16,LOW(50000)
		ldi	r17,HIGH(50000)		;	
		rjmp	minla_cfreq_20

minla_cfreq_03:	cpi	tempreg4,3		;200k
		brne	minla_cfreq_04
		ldi	r16,LOW(20000)
		ldi	r17,HIGH(20000)		;			
		rjmp	minla_cfreq_20
		
minla_cfreq_04:	cpi	tempreg4,4		;100k
		brne	minla_cfreq_05
		ldi	r16,LOW(10000)
		ldi	r17,HIGH(10000)		;			
		rjmp	minla_cfreq_20
		
minla_cfreq_05:	ldi	ctrl,0x3e		;2+3
		cpi	tempreg4,5		;50k
		brne	minla_cfreq_06
		ldi	r16,LOW(50000)
		ldi	r17,HIGH(50000)		;			
		rjmp	minla_cfreq_20

minla_cfreq_06:	cpi	tempreg4,6		;20k
		brne	minla_cfreq_07
		ldi	r16,LOW(20000)
		ldi	r17,HIGH(20000)		;			
		rjmp	minla_cfreq_20

minla_cfreq_07:	cpi	tempreg4,7		;10k
		brne	minla_cfreq_08
		ldi	r16,LOW(10000)
		ldi	r17,HIGH(10000)		;			
		rjmp	minla_cfreq_20

minla_cfreq_08:	ldi	tempreg3,0x20		;space
		ldi	ctrl,0x1e		;4+1
		cpi	tempreg4,8		;5k
		brne	minla_cfreq_09
		ldi	r16,LOW(50000)
		ldi	r17,HIGH(50000)		;							
		rjmp	minla_cfreq_20

minla_cfreq_09:	cpi	tempreg4,9		;2k
		brne	minla_cfreq_10
		ldi	r16,LOW(20000)
		ldi	r17,HIGH(20000)		;			
		rjmp	minla_cfreq_20

minla_cfreq_10:	cpi	tempreg4,10		;1k
		brne	minla_cfreq_11
		ldi	r16,LOW(10000)
		ldi	r17,HIGH(10000)		;			
		rjmp	minla_cfreq_20

minla_cfreq_11:	ldi	ctrl,0x2e		;3+2
		cpi	tempreg4,11		;500
		brne	minla_cfreq_12
		ldi	r16,LOW(50000)
		ldi	r17,HIGH(50000)		;									
		rjmp	minla_cfreq_20

minla_cfreq_12:	cpi	tempreg4,12		;200
		brne	minla_cfreq_13
		ldi	r16,LOW(20000)
		ldi	r17,HIGH(20000)		;							
		rjmp	minla_cfreq_20

minla_cfreq_13:	ldi	r16,LOW(10000)
		ldi	r17,HIGH(10000)		;							
		
minla_cfreq_20:	movw	YL,XL
		lsr	YH
		ror	YL
		add	r16,YL
		adc	r17,YH
		call	expar_udiv		;divide
		ret
		
		
;------------------------------------------------------------------------------
;view cursor
;------------------------------------------------------------------------------			
minla_scur0:	sts	libmio_color,const_0
		rjmp	minla_scur

minla_scur1:	sts	libmio_color,const_1
minla_scur:	lds	YL,rdata_ram+6		;cursor pos
		lsl	YL
		subi	YL,0xef		
		mov	ZL,YL
		ldi	YH,10
		ldi	ZH,14
		libmio_fbox	
		ldi	YH,24
		ldi	ZH,26
		libmio_fbox	
		ldi	YH,36
		ldi	ZH,39
		libmio_fbox	
		ret
								
;-----------------------------------------------------------------------------
; show wave frame 
; rdata_ram+0	low windowposition
; rdata_ram+1	high windowposition
; rdata_ram+4	low markposition
; rdata_ram+5	high markposition
;-----------------------------------------------------------------------------			
minla_show:	ldi	YL,LOW(libmio_vram+162)
		ldi	YH,HIGH(libmio_vram+162)
		ldi	XH,30			;lines
minla_show_1:	ldi	XL,12
minla_show_2:	st	Y+,const_0		;clear byte
		dec	XL
		brne	minla_show_2
		ld	tempreg1,Y
		andi	tempreg1,0xf0		;start byte
		st	Y+,tempreg1
		adiw	YL,3
		dec	XH
		brne	minla_show_1		;loop
		sts	libmio_color,const_1

;draw curve 1+2		
		lds	XL,rdata_ram+0		;position
		lds	XH,rdata_ram+1		
		ldi	ZL,LOW(rdata_buf)	;buffer
		ldi	ZH,HIGH(rdata_buf)
		add	ZL,XL			;add offset
		adc	ZH,XH
		ld	tempreg5,Z		;get data
		ldi	XL,16			;first pos	
minla_show_10:	ld	tempreg4,Z+		;get values

;show level1 (tempreg4.0)
minla_slev1:	ldi	XH,34			;LOW
		sbrc	tempreg5,0		;old
		ldi	XH,28			;HIGH
		libmio_plot
		ldi	YH,34
		sbrc	tempreg4,0
		ldi	YH,28
minla_slev1_1:	cp	XH,YH
		breq	minla_slev1_4		;done
		brcs	minla_slev1_2		;is smaller
		dec	XH
		libmio_plot
		rjmp	minla_slev1_1
minla_slev1_2:	inc	XH
		libmio_plot
		rjmp	minla_slev1_1								
minla_slev1_4:	inc	XL
		libmio_plot
		dec	XL

;show level2 (tempreg4.1)
minla_slev2:	ldi	XH,22			;LOW
		sbrc	tempreg5,1		;old
		ldi	XH,16			;HIGH
		libmio_plot
		ldi	YH,22
		sbrc	tempreg4,1
		ldi	YH,16
minla_slev2_1:	cp	XH,YH
		breq	minla_slev2_4		;done
		brcs	minla_slev2_2		;is smaller
		dec	XH
		libmio_plot
		rjmp	minla_slev2_1
minla_slev2_2:	inc	XH
		libmio_plot
		rjmp	minla_slev2_1								
minla_slev2_4:	inc	XL
		libmio_plot
		inc	XL
		mov	tempreg5,tempreg4	;set this as old

		cpi	XL,116			;end
		brcs	minla_show_10
		ret		
				

;------------------------------------------------------------------------------
;samplerate-data
;------------------------------------------------------------------------------
minla_srd:	.db	LOW(1),HIGH(1)		;Mode 1
		.db	LOW(5),HIGH(5)		;Mode 2
		.db	LOW(17),HIGH(17)	;Mode 3
		.db	LOW(37),HIGH(37)	;Mode 4
		.db	LOW(77),HIGH(77)	;Mode 5
		.db	LOW(197),HIGH(197)	;Mode 6
		.db	LOW(397),HIGH(397)	;Mode 7
		.db	LOW(797),HIGH(797)	;Mode 8
		.db	LOW(1997),HIGH(1997)	;Mode 9
		.db	LOW(3997),HIGH(3997)	;Mode 10
		.db	LOW(7997),HIGH(7997)	;Mode 11
		.db	LOW(19997),HIGH(19997)	;Mode 12
		.db	LOW(39997),HIGH(39997)	;Mode 13				
		
minla_cdata_s:	.db "  4M/s"
		.db "  1M/s"
		.db "500k/s"
		.db "200k/s"
		.db "100k/s"
		.db " 50k/s"
		.db " 20k/s"
		.db " 10k/s"
		.db "  5k/s"
		.db "  2k/s"
		.db "  1k/s"
		.db " 500/s"
		.db " 200/s"
		.db " 100/s"
		

		           	
