;################################################################################
;#										#
;# avr-chipbasic2M - mobile single chip basic computer with ATmega644		#
;# voltmeter functions								#
;# copyright (c) 2008 Joerg Wolfram (joerg@jcwolfram.de)			#
;#										#
;#										#
;# This program is free software; you can redistribute it and/or		#
;# modify it under the terms of the GNU General Public License			#
;# as published by the Free Software Foundation; either version 2		#
;# of the License, or (at your option) any later version.			#
;#										#
;# This program is distributed in the hope that it will be useful,		#
;# but WITHOUT ANY WARRANTY; without even the implied warranty of		#
;# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.See the GNU		#
;# General Public License for more details.					#
;#										#
;# You should have received a copy of the GNU General Public			#
;# License along with this library; if not, write to the			#
;# Free Software Foundation, Inc., 59 Temple Place - Suite 330,			#
;# Boston, MA 02111-1307, USA.							#
;#										#
;################################################################################

;------------------------------------------------------------------------------
;main screen mask
;------------------------------------------------------------------------------
volt_main:	ldi	ZL,LOW(libmio_icons*2+370)
		ldi	ZH,HIGH(libmio_icons*2+370)
		libmio_appframe
		ldi	XL,37
		ldi	XH,0
		ldi	ZL,LOW(volt_text_1*2)	;text pointer
		ldi	ZH,HIGH(volt_text_1*2)
		libmio_xztext					

		call	mincu_adcinit
		mov	tempreg7,const_0	;6v
		
volt_main_2:
		ldi	XL,0x01			;color (white on black)
		libmio_setcolor
		libmio_thistext		
		.db 41,32,"MAX:",0,0
		libmio_thistext		
		.db 52,32,"MIN:",0,0		
		ldi	YL,31
		ldi	YH,31
		ldi	ZL,97
		ldi	ZH,36
		libmio_box
		ldi	YL,64
		ldi	YH,29
		ldi	ZL,64
		ldi	ZH,38
		libmio_fbox
		libmio_nokey
		rcall	volt_get
		mov	r18,r16			;set min
		mov	r19,r16			;set max
		rjmp	volt_loop_1		
		
volt_loop:	rcall	volt_get
		rcall	volt_minmax
		
volt_loop_1:	libmio_thistext
		.db	10,28,0,0
		ldi	ctrl,0x67
		sbrc	tempreg7,0
		ldi	ctrl,0x57
		mov	XL,r16			;recent
		subi	XL,0x80
		rcall	volt_vval
		
		ldi	ctrl,0x27
		sbrc	tempreg7,0
		ldi	ctrl,0x17
		libmio_thistext
		.db	41,60,0,0
		mov	XL,r19			;max
		subi	XL,0x80
		rcall	volt_vval

		libmio_thistext
		.db	52,60,0,0
		mov	XL,r18			;min
		subi	XL,0x80
		rcall	volt_vval

		cp	r16,tempreg8
		breq	volt_loop_3
		
		sts	libmio_color,const_0
		ldi	YL,32
		ldi	YH,32
		ldi	ZL,63
		ldi	ZH,35
		libmio_fbox
		ldi	YL,65
		ldi	YH,32
		ldi	ZL,96
		ldi	ZH,35
		libmio_fbox
		sts	libmio_color,const_1

		mov	tempreg3,r16
		lsr	tempreg3
		lsr	tempreg3
		cpi	tempreg3,0x20 		;positive
		brcc	volt_loop_2		;yes
		ldi	YL,32
		ldi	YH,32
		ldi	ZL,63
		ldi	ZH,35
		add	YL,tempreg3
		libmio_fbox
		rjmp	volt_loop_3
		
volt_loop_2:	ldi	YL,64
		ldi	YH,32
		ldi	ZL,32
		ldi	ZH,35
		add	ZL,tempreg3
		libmio_fbox
		
		
		
volt_loop_3:	mov	tempreg8,r16		

volt_wloop_1:	lds	tempreg1,libmio_keycode
		cpi	tempreg1,0
		brne	volt_wloop_2
		rjmp	volt_loop
		
volt_wloop_2:	cpi	tempreg1,0xed		;ESC
		brne	volt_wloop_3
		ret

volt_wloop_3:	cpi	tempreg1,0xea		;ENTER=freeze
		brne	volt_wloop_4
		rcall	volt_went
		rjmp	volt_loop
		
		
volt_wloop_4:	cpi	tempreg1,0xe5		;DOWN=SET
		brne	volt_wloop_5
		mov	r18,r16
		mov	r19,r16
		rjmp	volt_loop
		
volt_wloop_5:	cpi	tempreg1,0xe4		;UP=6V
		brne	volt_wloop_6
		mov	tempreg7,const_0
		rjmp	volt_loop

volt_wloop_6:	mov	tempreg7,const_1	;LR=64V
		rjmp	volt_loop
	
		rjmp	volt_loop		
		
	
volt_went:	sts	libmio_color,const_0
		libmio_thistext
		.db	16,20,"F",0	
		libmio_nokey
		libmio_sync
volt_went_1:	lds	tempreg1,libmio_keycode
		cpi	tempreg1,0xea
		brne	volt_went_1
		sts	libmio_color,const_1	
		libmio_thistext
		.db	16,20," ",0	
		libmio_nokey
		libmio_sync
		ret
		
		
volt_get:	ldi	XL,0
		ldi	XH,0
		clr	tempreg2
volt_get_1:	call	mincu_getadc
		libmio_sync
		cpi	tempreg2,16
		brne	volt_get_1
		ldi	tempreg2,4
		add	XL,tempreg2
		adc	XH,const_0
		lsr	XH
		ror	XL
		lsr	XH
		ror	XL
		lsr	XH
		ror	XL
		lsr	XH
		ror	XL		
		mov	r16,XL
		ret	
		
		
volt_minmax:	cp	r16,r18			;less than min
		brcc	volt_minmax1
		mov	r18,r16
volt_minmax1:	cp	r19,r16			;greater than max
		brcc	volt_minmax2
		mov	r19,r16
volt_minmax2:	ret
		

volt_vval:	push	r16
		push	r17
		push	r18
		push	r19
		clr	XH
		sbrc	XL,7
		ldi	XH,0xff
		ldi	r16,5
		ldi	r17,0
		call	expar_mul
		sts	libmio_color,const_1
		sts	libmio_font,const_0
		libmio_outdez
		ldi	tempreg1,'V'
		libmio_outchar
		pop	r19
		pop	r18
		pop	r17
		pop	r16
		ret
